using System;
using System.Data;
using System.Data.SqlTypes;
using System.Data.SqlClient;
using System.Windows.Forms;
using metadatalibrary;
using CrystalDecisions.Shared;
using CrystalDecisions.CrystalReports.Engine;
using System.Collections;
using System.Text;
using System.IO;
using System.Xml;
using System.Security;
using System.Security.Cryptography;
using  System.Net;
using System.Threading;
using System.Collections.Generic;

namespace metaeasylibrary {

//	[Serializable]
//	public class ListaConnessioni:MarshalByRefObject {
//		public byte []lista;
//		public ListaConnessioni(byte []L){
//			lista=L;
//		}
//	}

	public class EasyDataAccessLoader:MarshalByRefObject{
		//int N=0;
		ArrayList Conns;
		public EasyDataAccessLoader(){ 
			Conns=new ArrayList();
		}

		public byte [] CurrentConnections(bool ping){
			DataSet D = new DataSet("Current");
			DataTable T = new DataTable("current");
			T.Columns.Add("Server");
			T.Columns.Add("Dep");
			T.Columns.Add("DB");
			T.Columns.Add("User");
			T.Columns.Add("esercizio");
			T.Columns.Add("ReadOnly");
			T.Columns.Add("LastRead");
			T.Columns.Add("LastWrite");
			if (ping) T.Columns.Add("ping");
			D.Tables.Add(T);
			int i=0;
			while (i< Conns.Count){
				if (Conns[i]==null) {
					Conns.RemoveAt(i);
					continue;
				}
				Easy_DataAccess Conn = Conns[i] as Easy_DataAccess;
				if (Conn==null) {
					Conns.RemoveAt(i);
					continue;
				}
				if(Conn.sys["server"].ToString()==""){
					Conns.RemoveAt(i);
					continue;
				}
				i++;				
			}
			for (i=0; i< Conns.Count;i++){
				Easy_DataAccess Conn = Conns[i] as Easy_DataAccess;
				if (Conn==null) continue;
				if (Conn.OpenError) {
					continue;
				}
				DataRow R = T.NewRow();
				R["Server"]= Conn.sys["server"].ToString();
				R["Dep"]= Conn.sys["userdb"].ToString();
				R["DB"]= Conn.sys["database"].ToString();
				R["User"]= Conn.sys["user"].ToString();
				R["esercizio"]=Conn.GetEsercizio();
				if (Conn.ReadOnly)
					R["ReadOnly"]="S";
				else
					R["ReadOnly"]="N";
				try {
					if (Conn.sys["DataAccessLastRead"]!=null){
						R["LastRead"]= ((DateTime)Conn.sys["DataAccessLastRead"]).ToString("T") ;
						TimeSpan TS= DateTime.Now - (DateTime)Conn.sys["DataAccessLastRead"];
						if (TS.Minutes>59) Conn.MyClose();
					}
					if (Conn.sys["DataAccessLastWrite"]!=null)
						R["LastWrite"]= ((DateTime)Conn.sys["DataAccessLastWrite"]).ToString("T") ;
					if (ping){
						crono C = new crono("ping dataaccess");
						//int U = metaprofiler.StartTimer("ping DataAccess");
						Conn.RUN_SELECT("customobject","*",null,"(objectname='customobject')","1",true);
						long delay = C.GetDuration();
						R["ping"]=delay.ToString();
					}
				}
				catch{};
				T.Rows.Add(R);
			}
			return DataAccess.PackDataSet(null,D);
//			byte [] l = DataAccess.PackDataSet(null,D);
//			MessageBox.Show("CI SONO!!!");
//			return ; //new ListaConnessioni(l);

		}

		void InitDataAccess(Easy_DataAccess C){
			Conns.Add(C);
			try {
				DataSet DS= new DataSet();
				DS.ReadXml("3tierconfig.xml");				
				DataTable T= DS.Tables[0];
				DataRow R=T.Rows[0];
				C.MySetUsr("localreportdir",R["localreportdir"].ToString());

				//MessageBox.Show(R["report"].ToString());
				//MessageBox.Show(System.Environment.UserName);
			}
			catch (Exception E) {
				QueryCreator.MarkEvent(QueryCreator.GetErrorString(E));
				//MessageBox.Show(QueryCreator.GetErrorString(E));
			}
			AppDomain.CurrentDomain.SetData("red","1");

		}



		public Easy_DataAccess GetDataAccess(string DSN, byte []Server, 
			byte []Database, 
			byte []User,
			byte []Password,
			byte []Dipartimento,
			byte []OldPwd,
			int esercizio_sessione, 
			DateTime DataContabile,
			out string error,
			out string dettaglio){
			Easy_DataAccess C =   Easy_DataAccess.getEasyDataAccess(
				DSN,
				Easy_DataAccess.DecryptPassword(Server),
				Easy_DataAccess.DecryptPassword(Database),
				Easy_DataAccess.DecryptPassword(User),
				Easy_DataAccess.DecryptPassword(Password),
				Easy_DataAccess.DecryptPassword(OldPwd),
				Easy_DataAccess.DecryptPassword(Dipartimento),
				esercizio_sessione, DataContabile, out error, out dettaglio);
			if (C!=null){
				InitDataAccess(C);
			}
			return C;
		}

	}
    public struct allowdeny {
        public string allow;
        public string deny;
        public bool defaultisdeny;
        public allowdeny(string allow, string deny, bool defaultisdeny) {
            this.allow = allow;
            this.deny = deny;
            this.defaultisdeny = defaultisdeny;
        }
    }

    public class SecurityConditions {
        Dictionary<string, List<allowdeny>> conditions = new Dictionary<string, List<allowdeny>>();

        private string getKey(string table, string op) {
            return table.ToLower() + "/" + op.ToLower();
        }

        
        public void Add(string table, string op, allowdeny AD) {
            string key =getKey(table, op);
            List<allowdeny> L = null;
            if (conditions.ContainsKey(key)) {
                L = conditions[key];
            }
            else {
                L = new List<allowdeny>();
                conditions[key] = L;
            }
            L.Add(AD);

        }


        public List<allowdeny> Get(string table, string op) {
            string key = getKey(table, op);
            if (!conditions.ContainsKey(key)) return new List<allowdeny>();
            return conditions[key];
        }
    }

	[Serializable]
	public class Easy_DataAccess: DataAccess{
		public bool ReadOnly;

        SecurityConditions GroupOperations;



		internal void MySetUsr(string key, object O){
			SetUsr(key,O);
		}

		private static byte [] GetArr1(){
			byte []arr=	new byte[]{75,12,0,215+13,   93,89-19,45,11,   171,96+65,4,64,  13+8,158,36,190};
			arr[3]-= 13;
			arr[5]+=19;
			arr[9]-=65;
			arr[12]-=8;
			return arr;
		}

		public static string DecryptPassword(byte []pwd){
			/*
			 * char[] a= pwd.ToCharArray();
			byte []A = new byte[a.Length];
			for (int i=0; i<a.Length; i++) A[i]= Convert.ToByte(a[i]);
			*/

			MemoryStream MS = new MemoryStream();
			CryptoStream CryptoS = new CryptoStream(MS,
				new TripleDESCryptoServiceProvider().CreateDecryptor(
				GetArr1(),
				new byte[]{68,13,99,43, 149,192,145,43, 83,19,238,57, 128,38,12,4}
				), CryptoStreamMode.Write);
			CryptoS.Write(pwd,0,pwd.Length);
			CryptoS.Flush();
			return Encoding.Default.GetString(MS.ToArray()).TrimEnd();
		}

		public static byte [] CryptPassword(string pwd){
			while ((pwd.Length % 8)!=0) pwd+=" ";
			char[] a= pwd.ToCharArray();
			byte []A = new byte[a.Length];
			for (int i=0; i<a.Length; i++) A[i]= Convert.ToByte(a[i]);

			MemoryStream MS = new MemoryStream(1000);
			CryptoStream CryptoS = new CryptoStream(MS,
				new TripleDESCryptoServiceProvider().CreateEncryptor(
				GetArr1(),
				new byte[]{68,13,99,43, 149,192,145,43, 83,19,238,57, 128,38,12,4}
				), CryptoStreamMode.Write);
			CryptoS.Write(A,0,A.Length);
			CryptoS.FlushFinalBlock();

			byte  [] B = MS.ToArray();
			return B;
			/*
			char []b = new char[B.Length];
			for (int i=0; i<B.Length; i++) b[i]= Convert.ToChar(B[i]);
			return new string(b);
			*/
		}
		public  byte[] sha256Password() {
			string passwordDB = DecryptKey((byte[]) GetSys("password"));
			SHA256 shaM = new SHA256Managed(); 
			UTF8Encoding encoding = new UTF8Encoding();
			byte[] alfa = shaM.ComputeHash(encoding.GetBytes(passwordDB));
			return alfa;
		}

		internal void MyClose(){
			SureClosing();
		}

		#region Costruttori




		

        protected Easy_DataAccess(bool MainConn,string DSN, string Server, 
			string Database, 
			string UserDB,
			string PasswordDB,
			string User, 
			string Password,
			int esercizio_sessione, 
			DateTime DataContabile):
			base(MainConn, DSN,Server,Database,
			UserDB, PasswordDB,
			User,Password,
			esercizio_sessione,DataContabile) {
			if (OpenError) return;
            if (DSN == "skipsecurity") return;
			CalculateGroupList();
			RecalcUserEnvironment();
			ReadAllGroupOperations();           
		}

		/// <summary>
		/// Constructuctor for SQL Based Security
		/// </summary>
		/// <param name="DSN"></param>
		/// <param name="Server"></param>
		/// <param name="Database"></param>
		/// <param name="User"></param>
		/// <param name="Password"></param>
		/// <param name="esercizio_sessione"></param>
		/// <param name="DataContabile"></param>
		public Easy_DataAccess(string DSN, string Server, 
			string Database, 
			string UserDB,
			string PasswordDB,
			string User, 
			string Password,
			int esercizio_sessione, 
			DateTime DataContabile):
			base(DSN,Server,Database,
			UserDB, PasswordDB,
			User,Password,
			esercizio_sessione,DataContabile) {
			if (OpenError) return;
			CalculateGroupList();
			RecalcUserEnvironment();
			ReadAllGroupOperations();
            if (Password == INITIAL_PASSWORD) {
                sys["initial_password_set"] = "S";
            }
            else {
                sys["initial_password_set"] = "N";
            }
		}

		public static Easy_DataAccess getEasyDataAccess (
			string DSN, 
			string Server, 
			string Database, 
			string User, 
			string Password,
			string idDbDepartment,
			int esercizio_sessione, 
			DateTime DataContabile,
			out string error,
			out string dettaglio) {
			return getEasyDataAccess (
						DSN, Server, Database, User, 
						Password,INITIAL_PASSWORD,idDbDepartment,esercizio_sessione, 
						DataContabile,out error,out dettaglio);
		}

		public static Easy_DataAccess getEasyDataAccess (
			string DSN, 
			string Server, 
			string Database, 
			string User, 
			string Password,
			string OldPassword,
			string idDbDepartment,
			int esercizio_sessione, 
			DateTime DataContabile,
			out string error,
			out string dettaglio) {
			DataAccess dataAccess = new AllLocal_DataAccess(DSN, Server, Database, 
				User, Password, User, Password, 
				esercizio_sessione, DataContabile);
			if (!dataAccess.Open()) {
				error = "Non  stato possibile effettuare il collegamento al database.";
				dettaglio = dataAccess.LastError;
				return null;
			}
			if (OldPassword==null || OldPassword=="" || OldPassword.Trim()=="") OldPassword=INITIAL_PASSWORD;
			string passwordDB = getRealDepartmentPassword(dataAccess, User, Password, OldPassword,
				idDbDepartment, out error);
			if (error != null) {
				dettaglio = null;
				return null;
			}
			Easy_DataAccess eda = new Easy_DataAccess(				
				DSN,
				Server,
				Database,
				idDbDepartment,
				passwordDB,
				User,
				Password,
				esercizio_sessione,
				DataContabile);
			error = eda.LastError;
			if (error=="") error=null;
			dettaglio = null;
			return eda;
		}

		public override bool TableIsCentralized(string tablename) {
			return false;
		}
		public override bool ProcedureIsCentralized(string procname) {
			return false;
		}


       


		/// <summary>
		/// Restituisce la password dell'utente criptata con SHA
		/// </summary>
		/// <returns></returns>
		public byte[] sha256UserPassword() {
			byte[] baPassword = (byte[]) GetSys("password");
			string password = DecryptKey(baPassword);
			return getAlfaFromPassword(password);
		}

		public static byte[] getAlfaFromPassword(string userPassword) {
			return SHA256.Create().ComputeHash(Encoding.Default.GetBytes(userPassword));
		}

		
		/// <summary>
		/// Esegue lo XOR tra due array di byte
		/// </summary>
		/// <param name="a"></param>
		/// <param name="b"></param>
		/// <returns></returns>
		private static byte[] xor(byte[] a, byte[] b) {
			BitArray orEsclusivo = new BitArray(a).Xor(new BitArray(b));
			byte[] result = new byte[32];
			orEsclusivo.CopyTo(result, 0);
			return result;
		}

		/// <summary>
		/// Restituisce la password del dipartimento a partire da alfa (password criptata dell'utente)
		/// e alfa'
		/// </summary>
		/// <param name="alfa"></param>
		/// <param name="alfa1"></param>
		/// <returns></returns>
		private static string getDepPassword(byte[] alfa, byte[] alfa1) {
			if ((alfa == null) || (alfa1 == null) || (alfa.Length != 32) || (alfa1.Length != 32)) {
				return null;
			}
			byte[] inputDiG = xor(alfa, alfa1);
			try {
				string obfuscated = DecryptString(inputDiG).ToUpper();
				return unObfuscatePassword(obfuscated);
			} catch (CryptographicException) {
				return null;
			}
		}

		public const string INITIAL_PASSWORD = "ABCDE12345";

		/// <summary>
		/// Cambia la password del'utente in automatico 
		/// </summary>
		/// <param name="rAccess">Riga che NON deve appartenere ad un DataSet</param>
		/// <param name="departmentPassword"></param>
		/// <returns></returns>
		private static bool fixDepartmentAccessPassword(string Server,string Database, string password,
				string departmentPassword, string iddbdepartment,  string user) {
			if ((departmentPassword == null) || (departmentPassword.Length > 31)) {
				return false;
			}

			DataAccess Conn = new AllLocal_DataAccess("temp", Server, Database, 
							iddbdepartment, departmentPassword, 
							iddbdepartment, departmentPassword, 
							DateTime.Now.Year, DateTime.Now);
			if (Conn==null) return false;
			Conn.Open();
			if (Conn.OpenError) {
				Conn.Destroy();
				return false;
			}

			string filtro = "(login=" + QueryCreator.quotedstrvalue(user, true)
				+ ") and (iddbdepartment=" + QueryCreator.quotedstrvalue(iddbdepartment, true)
				+ ")";

			DataTable tAccess = Conn.RUN_SELECT("dbaccess", null, null, filtro, null, null, false);
			//			DataTable tAccess = SQLRunner("select * from dbaccess");
			if (tAccess.Rows.Count == 0) return false;
			DataRow rAccess = tAccess.Rows[0];


			byte[] alfa = getAlfaFromPassword(password);//sha256UserPassword();
			byte[] g1 = DataAccess.CryptString(departmentPassword.PadRight(31));
			byte[] alfa1 = xor(alfa, g1);
			rAccess["alpha1"] = QueryCreator.ByteArrayToString(alfa1);

//			Conn.DO_UPDATE("dbaccess",filtro,new string []{"alpha1"}, 
//							new string []{QueryCreator.ByteArrayToString(alfa1)},1);
			DataSet ds = new DataSet();
			ds.Tables.Add(rAccess.Table);
			PostData epd = new PostData();
			epd.InitClass(ds, Conn);
			bool res = epd.DO_POST();

			Conn.Close();
			Conn.Destroy();
			return res;
		}


		public static string VALID_PWD_CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789;,:.-_'?!";

		/// <summary>
		/// Cambia casualmente il bit 7 di ciascun carattere della password
		/// </summary>
		/// <param name="password"></param>
		/// <returns></returns>
		private string obfuscatePassword(string password) {
			ArrayList list = new ArrayList();
			foreach (char c in VALID_PWD_CHARS) {
				byte b = Convert.ToByte(c);
				if (b>127) {
					list.Add(b);
				}
			}
			Random random = new Random();
			string result = "";
			foreach (char c in password) {
				int bit7 = random.Next(2) << 7;
				char c2 = (char)((int)c | bit7);
				if (list.IndexOf(c2)==-1) {
					result += c2;
				} else {
					result += c;
				}
			}
			return result;
		}


		/// <summary>
		/// A partire dalla password offuscata (con il bit 7 di ciascun carattere variato casualmente)
		/// restituisce la password iniziale
		/// </summary>
		/// <param name="obfuscated"></param>
		/// <returns></returns>
		private static string unObfuscatePassword(string obfuscated) {
			ArrayList list = new ArrayList();
			foreach (char c in VALID_PWD_CHARS) {
				byte b = (byte)c;
				if (b>127) {
					list.Add(b);
				}
			}
			string password = "";
			foreach (char c in obfuscated) {
				if (c > byte.MaxValue) {
					return null;
				}
				byte b = (byte) c;
				if ((b > 127) && (list.IndexOf(b) == -1)) {
					b -= 128;
				}
				char c2 = (char) b;
				if (VALID_PWD_CHARS.IndexOf(c2) == -1) {
					return null;
				}
				password += c2;
			}
			return password;
		}

		
		public static DataAccess GetAllLocalDataAccess(			
			string DSN, 
			string Server, 
			string Database, 
			string User, 
			string Password,
			string idDbDepartment,
			int esercizio_sessione, 
			DateTime DataContabile,
			out string error,
			out string dettaglio){
			return GetAllLocalDataAccess(			
						DSN, Server, Database, User, Password,
						INITIAL_PASSWORD,
						idDbDepartment,esercizio_sessione, DataContabile, out error,out dettaglio);
		}

		public static DataAccess GetAllLocalDataAccess(			
			string DSN, 
			string Server, 
			string Database, 
			string User, 
			string Password,
			string OldPassword,
			string idDbDepartment,
			int esercizio_sessione, 
			DateTime DataContabile,
			out string error,
			out string dettaglio){
			DataAccess dataAccess = new AllLocal_DataAccess(DSN, Server, Database, User, Password, User, Password,
				esercizio_sessione, DataContabile);
			if (!dataAccess.Open()) {
				error = "Non  stato possibile effettuare il collegamento al database.";
				dettaglio = dataAccess.LastError;
				return null;
			}
			string passwordDB = getRealDepartmentPassword(dataAccess, User, Password, OldPassword,
				idDbDepartment, out error);
			if (error != null) {
				dettaglio = null;
				return null;
			}
			DataAccess eda = new AllLocal_DataAccess(				
				DSN,
				Server,
				Database,
				idDbDepartment,
				passwordDB,
				User,
				Password,
				esercizio_sessione,
				DataContabile);
			error = eda.LastError;
			if (error=="") error=null;
			dettaglio = null;
			return eda;
		}

		/// <summary>
		/// Restituisce la password del dipartimento
		/// </summary>
		/// <param name="iddbdepartment"></param>
		/// <param name="error"></param>
		/// <returns></returns>
		private static string getRealDepartmentPassword(DataAccess dataAccess, string user, string password, 
			string oldpassword, 
			string iddbdepartment, out string error) {
			error = null;
            QueryHelper QHS= dataAccess.GetQueryHelper();
            string filtro = QHS.AppAnd(QHS.CmpEq("login", user), QHS.CmpEq("iddbdepartment", iddbdepartment));
			object SAlfa1 = dataAccess.DO_READ_VALUE("dbaccess",filtro,"alpha1");
			if (SAlfa1 == DBNull.Value || SAlfa1==null) {
				error = "L'utente non  abilitato a connettersi al dipartimento selezionato";
				return null;
			}
			string sAlfa1 = SAlfa1.ToString();
			if (sAlfa1 == "") {
				error = "Errore interno: E' nulla la password di aggancio tra l'utente "+user+" ed il dipartimento "+iddbdepartment;
				return null;
			}
			byte[] alfa1 = QueryCreator.StringToByteArray((string)sAlfa1);

			byte[] currAlfa = getAlfaFromPassword(password);//sha256UserPassword();
			string passwordDB = getDepPassword(currAlfa, alfa1);
			if (passwordDB == null) {								
				byte[] initAlfa = getAlfaFromPassword(oldpassword);
				passwordDB = getDepPassword(initAlfa, alfa1);
				if (!fixDepartmentAccessPassword(dataAccess.GetSys("server").ToString(),
								dataAccess.GetSys("database").ToString(), 
								password,  passwordDB, iddbdepartment, user)) {
					error = "La password inserita permette all'utente "+user
						+" di accedere al server ma non al dipartimento "+iddbdepartment;
					return null;
				}
			}
			return passwordDB;
		}

		/// <summary>
		/// Cambia la password dell'utente
		/// </summary>
		/// <param name="alfa2"></param>
		/// <returns></returns>
		public bool changeUserPassword(byte[] oldalfa, byte []newalfa) {
            string filtro = QHS.CmpEq("login", GetSys("user"));
			DataTable tAccess = this.RUN_SELECT("dbaccess", null, null, filtro, null, null, true);
			byte[] costante = xor(oldalfa, newalfa);
			foreach (DataRow rAccess in tAccess.Rows) {
				string sAlfa1 = (string) rAccess["alpha1"];
				byte[] alfa1 = QueryCreator.StringToByteArray(sAlfa1);
				byte[] nuovoAlfa1 = xor(costante, alfa1);
				rAccess["alpha1"] = QueryCreator.ByteArrayToString(nuovoAlfa1);
			}
			DataSet ds = new DataSet();
			ds.Tables.Add(tAccess);
			Easy_PostData epd = new Easy_PostData();
			epd.InitClass(ds, this);
			bool res= epd.DO_POST();
			return res;
		}

		public bool changeDepartmentPassword(byte[] oldPwd, byte[] newPwd) {
			string typedPwd = DecryptString(oldPwd);
			string PWDOLD = DecryptKey((byte[])GetSys("passworddb"));
			if (typedPwd != PWDOLD) {
				return false;
			}
			string PWDNEW = DecryptString(newPwd);
			byte[] oldg = CryptString(PWDOLD.PadRight(31));
			byte[] newg = CryptString(PWDNEW.PadRight(31));
			byte[] costante = xor(oldg, newg);

			string iddbdepartment = (string) GetSys("userdb");
            string filtro = QHS.CmpEq("iddbdepartment", iddbdepartment);
			DataTable tAccess = RUN_SELECT("dbaccess", null, null, filtro, null, null, false);
			foreach (DataRow rAccess in tAccess.Rows) {
				string sAlfa1 = (string) rAccess["alpha1"];
				byte[] alfa1 = QueryCreator.StringToByteArray(sAlfa1);
				byte[] nuovoAlfa1 = xor(costante, alfa1);
				rAccess["alpha1"] = QueryCreator.ByteArrayToString(nuovoAlfa1);
			}

			DataSet ds = new DataSet();
			ds.Tables.Add(tAccess);
			Easy_PostData epd = new Easy_PostData();
			epd.InitClass(ds, this);
			bool res = epd.DO_POST();
			return res;
		}


		/// <summary>
		/// Abilita un utente ad accedere ad un dipartimento. Restituisce la connessione a tale dipartimento.
		/// DETTAGLI:
		/// Prova a connettersi al dipartimento con user=iddbdepartment e password=depPasswordToTry
		/// Se ci riesce allora aggiorna le tabelle dbdepartment, dbaccess e duser affinch
		/// da ora in poi l'utente potr accedere a tale dipartimento con la sua user e password.
		/// </summary>
		/// <param name="Conn"></param>
		/// <param name="userPwd"></param>
		/// <param name="idDbDepartment"></param>
		/// <param name="depPasswordToTry"></param>
		/// <param name="readConfiguration">true se deve eseguire 			
		/// CalculateGroupList(), RecalcUserEnvironment() e	ReadAllGroupOperations();</param>
		/// <param name="error"></param>
		/// <returns></returns>
		public static void linkUserToDepartment(DataAccess Conn, string username, string userPwd,
			string idDbDepartment, string depPassword, out string error) {
			byte[] alfa = getAlfaFromPassword(userPwd);
			byte[] g = CryptString(depPassword.PadRight(31));

			error = null;
			byte[] alfa1 = xor(alfa, g);
            QueryHelper QHS= Conn.GetQueryHelper();
			string utente = username;
            string filtroUser = QHS.CmpEq("login", utente);
            string filtroDep = QHS.CmpEq("iddbdepartment", idDbDepartment);
            string filtroAccess = QHS.AppAnd(filtroUser, filtroDep);

			int utenti = Conn.RUN_SELECT_COUNT("dbuser", filtroUser, false);
			int dipartimenti = Conn.RUN_SELECT_COUNT("dbdepartment", filtroDep, false);
			int accessi = Conn.RUN_SELECT_COUNT("dbaccess", filtroAccess, false);

			if (utenti == 0) {
				error = Conn.DO_INSERT("dbuser", 
					new string[] {"login"}, 
					new string[] {QHS.quote(utente)}, 1);
				if (error != null) {
					return;
				}
			}
			if (dipartimenti == 0) {
				error = Conn.DO_INSERT("dbdepartment", 
					new string[] {"iddbdepartment"},
					new string[] {QHS.quote(idDbDepartment)}, 1);
				if (error != null) {
					return;
				}
			}
			if (accessi == 0) {
				string sAlfa1 = QueryCreator.ByteArrayToString(alfa1);
				error = Conn.DO_INSERT("dbaccess", 
					new string[] {"login", "iddbdepartment", "alpha1"},
					new string[] {	 QHS.quote(utente), 
									 QHS.quote(idDbDepartment), 
									 QHS.quote(sAlfa1)
								 }, 3);
				if (error != null) {
					return;
				}
			}
			else {
				string sAlfa2 = QueryCreator.ByteArrayToString(alfa1);
				error = Conn.DO_UPDATE("dbaccess", filtroAccess,
					new string[] {"alpha1"},
					new string[] {QHS.quote(sAlfa2)
								 }, 1);
				if (error != null) {
					return;
				}
			}
			//			return eda;
		}

		public void linkUserToDepartment(string username, out string error) {
			string iddepartment= GetSys("userdb").ToString();
			string deppassword= DecryptKey( (byte[])GetSys( "passworddb"));


			byte[] alfa = getAlfaFromPassword(INITIAL_PASSWORD);
			byte[] g = CryptString(deppassword.PadRight(31));

			error = null;
			byte[] alfa1 = xor(alfa, g);

			string utente = username;
            string filtroUser = QHS.CmpEq("login", username);
            string filtroDep = QHS.CmpEq("iddbdepartment", iddepartment);
            string filtroAccess = QHS.AppAnd(filtroUser, filtroDep);

			int utenti = RUN_SELECT_COUNT("dbuser", filtroUser, false);
			int dipartimenti = RUN_SELECT_COUNT("dbdepartment", filtroDep, false);
			int accessi = RUN_SELECT_COUNT("dbaccess", filtroAccess, false);

			if (utenti == 0) {
				error = DO_INSERT("dbuser", 
					new string[] {"login"}, 
					new string[] {QHS.quote(username)}, 1);
				if (error != null) {
					return;
				}
			}
			if (dipartimenti == 0) {
				error = DO_INSERT("dbdepartment", 
					new string[] {"iddbdepartment"},
					new string[] {QHS.quote(iddepartment)}, 1);
				if (error != null) {
					return;
				}
			}
			if (accessi == 0) {
				string sAlfa1 = QueryCreator.ByteArrayToString(alfa1);
				error = DO_INSERT("dbaccess", 
					new string[] {"login", "iddbdepartment", "alpha1"},
					new string[] {	 QHS.quote(username), 
									 QHS.quote(iddepartment), 
									 QHS.quote(sAlfa1)
								 }, 3);
				if (error != null) {
					return;
				}
			}
			else {
				string sAlfa2 = QueryCreator.ByteArrayToString(alfa1);
				error = DO_UPDATE("dbaccess", filtroAccess,
					new string[] {"alpha1"},
                    new string[] {QHS.quote(sAlfa2)
								 }, 1);
				if (error != null) {
					return;
				}

			}

			//			return eda;
		}





		/// <summary>
		/// Crea un duplicato di un DataAccess, con una nuova connessione allo stesso DB. 
		/// Utile se la connessione deve essere usata in un nuovo thread.
		/// </summary>
		/// <returns></returns>
		override public DataAccess Duplicate(){
			DataAccess D= new Easy_DataAccess(
				false,
				"skipsecurity",
				sys["server"].ToString(),
				sys["database"].ToString(),
				sys["userdb"].ToString(),
				DecryptKey((byte[]) sys["passworddb"]),
				sys["user"].ToString(),
				DecryptKey((byte[]) sys["password"]),
				GetEsercizio(),
				(DateTime) sys["datacontabile"]);
            D.external_user = this.external_user;
            return D;			
		}

		#endregion




		
		#region CALL SP varie redirette tramite customprocedure

		public override DataSet CallSP(string procname, object[] list, bool silent, int timeout) {
            //object customname = DO_READ_VALUE("customprocedure",
            //    QHS.CmpEq("officialname",procname),
            //    "customname");
            //if ((customname!=null)&&(customname!=DBNull.Value)){
            //    if (customname.ToString().Trim()!="") procname= customname.ToString().Trim();
            //}
			return base.CallSP (procname, list, silent,timeout);
		}



		public override bool CallSPParameter(string sp_name, string[] ParamName, SqlDbType[] ParamType, int[] ParamTypeLength, ParameterDirection[] ParamDirection, ref object[] ParamValues, int timeout, out string ErrMsg) {
			object customname = DO_READ_VALUE("customprocedure",
                QHS.CmpEq("officialname", sp_name),
				"customname");
			if ((customname!=null)&&(customname!=DBNull.Value)){
				if (customname.ToString().Trim()!="") sp_name= customname.ToString().Trim();
			}
			return base.CallSPParameter (sp_name, ParamName, ParamType, ParamTypeLength, ParamDirection, ref ParamValues, timeout, out ErrMsg);
		}


		public override DataSet CallSPParameterDataSet(string sp_name, string[] ParamName, SqlDbType[] ParamType, int[] ParamTypeLength, ParameterDirection[] ParamDirection, ref object[] ParamValues, int timeout, out string ErrMsg) {
			object customname;
			if (sp_name.ToLower().StartsWith("check_")){
				customname=sp_name;
			}
			else {
				customname= DO_READ_VALUE("customprocedure",
                    QHS.CmpEq("officialname",sp_name),
					  "customname");
				if ((customname!=null)&&(customname!=DBNull.Value)){
					if (customname.ToString().Trim()!="") sp_name= customname.ToString().Trim();
				}
			}

			return base.CallSPParameterDataSet (sp_name, ParamName, ParamType, ParamTypeLength, ParamDirection, ref ParamValues, timeout, out ErrMsg);
		}

		#endregion



		#region Gestione Sicurezza


		public void ReadAllGroupOperations(){
            int handler = metaprofiler.StartTimer("ReadAllGroupOperations()");
			string grouplist = GetGroupList();
            DataRowReader Dr = null;
			try {
				if ((grouplist==null)||(grouplist=="")) {
                    Dr = new DataRowReader(this, "customgroupoperation", "*", null, QHS.IsNull("idgroup"));
                    //GroupOperations= RUN_SELECT(
                    //    "customgroupoperation", "*", null, 
                    //    QHS.IsNull("idgroup"),
                    //    null,null,true);
				}
				else {
                    Dr = new DataRowReader(this, "customgroupoperation", "*", null, QHS.FieldInList("idgroup", grouplist));
                    //GroupOperations= RUN_SELECT(
                    //    "customgroupoperation", "*", null, 
                    //    QHS.FieldInList("idgroup",grouplist),
                    //    null,null,true);
				}
			}
			catch {
			}
            GroupOperations = new SecurityConditions();

            foreach (DataRow R in Dr) {
                string allow = EasyAudits.NormalizeExpression(Compile(R["allowcondition"].ToString(), false));
                string deny = EasyAudits.NormalizeExpression(Compile(R["denycondition"].ToString(), false));
                bool defaultisdeny = true;
                if (R["defaultisdeny"].ToString().ToUpper() != "S") defaultisdeny = false;
                GroupOperations.Add(R["tablename"].ToString(), R["operation"].ToString(), new allowdeny(allow, deny,defaultisdeny));
            }

            ////Compila le condizioni
            //if (GroupOperations !=null){
            //    foreach (DataRow R in GroupOperations.Rows){
            //        R["allowcondition"]= Compile(R["allowcondition"].ToString(),false);
            //        R["denycondition"]= Compile(R["denycondition"].ToString(),false);
            //        R.AcceptChanges();
            //    }
            //}
            ////Normalizza le condizioni in ingresso
            //if (GroupOperations !=null){
            //    foreach (DataRow R in GroupOperations.Rows){
            //        R["allowcondition"]= EasyAudits.NormalizeExpression(R["allowcondition"].ToString());
            //        R["denycondition"]= EasyAudits.NormalizeExpression(R["denycondition"].ToString());
            //        R.AcceptChanges();
            //    }
            //}
            metaprofiler.StopTimer(handler);


		}

		List<allowdeny> GetCustomGroupOperation(DataTable T, string OpCode){
            if (GroupOperations == null) return new List<allowdeny>();
			string realtable= QueryCreator.PostingTableName(T);
			if (OpCode.ToUpper()=="S") realtable= T.TableName;
            return GroupOperations.Get(realtable, OpCode);
                        //GetCustomGroupOperation(realtable, OpCode);
		}


        List<allowdeny> GetCustomGroupOperation(string tablename, string OpCode) {
            if (GroupOperations == null) return new List<allowdeny>();

            int handle = metaprofiler.StartTimer("GetCustomGroupOperation");
            try {
                return GroupOperations.Get(tablename, OpCode);
            }
            finally {
                metaprofiler.StopTimer(handle);
            }

            //try {
            //    string grouplist = GetGroupList();
            //    if (string.IsNullOrEmpty(grouplist)) return null;


            //    if (GroupOperations != null) {
            //        string filterC = QHC.AppAnd(QHC.CmpEq("tablename", tablename),
            //        QHC.CmpEq("operation", OpCode),
            //        QHC.FieldInList("idgroup", grouplist));
            //        try {
            //            return GroupOperations.Select(filterC);
            //        }
            //        catch {
            //        }
            //        return null;
            //    }

            //    string filter = QHS.AppAnd(QHS.CmpEq("tablename", tablename),
            //        QHS.CmpEq("operation", OpCode),
            //        QHS.FieldInList("idgroup", grouplist));

            //    DataTable CustomGroupOperation = null;
            //    try {
            //        CustomGroupOperation = RUN_SELECT(
            //            "customgroupoperation", "*", null,
            //            filter,
            //            null, null, true);
            //    }
            //    catch {
            //    }
            //    if (CustomGroupOperation == null) return null;
            //    return CustomGroupOperation.Select();
            //}
            //finally {
            //    metaprofiler.StopTimer(handle);
            //}
		}

		/// <summary>
		/// Must return false if the given row can be selected with "mainselect" in the
		///  form named edit_type. Should also display to user the reason for which 
		///  row can't be selected.
		/// </summary>
		/// <param name="R"></param>
		/// <returns></returns>
		override public bool CanSelect(DataRow R){
			if (R==null) return true;
			List<allowdeny> CustomGroupOperations = GetCustomGroupOperation(R.Table,"S");
			if (CustomGroupOperations.Count>0)
				return CheckCustomOperation(CustomGroupOperations, R);
			else
				return true;

		}

        public override string SelectCondition(string tablename,bool SQL) {
            List<allowdeny> CustomGroupOperations = GetCustomGroupOperation(tablename, "S");
            if (CustomGroupOperations == null) return null;
            if (CustomGroupOperations.Count == 0) return null;

            QueryHelper QH;
            if (SQL) {
                QH = GetQueryHelper();
            }
            else {
                QH = new CQueryHelper();
            }
            string pre_allowcondition = "";
            bool do_precheck = true;

            //bool defaultisdeny = true;//general default
            foreach (allowdeny GOp in CustomGroupOperations) {
                string allow = GOp.allow;
                string deny = GOp.deny;

                string pre_allow = allow;
                string pre_deny = deny;

                if (allow.StartsWith("&")) {
                    pre_allow = allow.Substring(1);
                }
                if (allow.StartsWith("%")) {
                    pre_allow = allow.Substring(1);
                }

                if (deny.StartsWith("&")) {
                    pre_deny = deny.Substring(1);
                }
                if (deny.StartsWith("%")) {
                    pre_deny = deny.Substring(1);
                }

                if (pre_deny.StartsWith("AND(")) pre_deny = pre_deny.Substring(3);
                if (pre_allow.StartsWith("AND(")) pre_allow = pre_allow.Substring(3);

                while (pre_deny.Contains("AND(1=1)")) pre_deny = pre_deny.Replace("AND(1=1)", "");
                while (pre_allow.Contains("AND(1=1)")) pre_allow = pre_allow.Replace("AND(1=1)", "");
                while (pre_deny.Contains("(1=1)AND")) pre_deny = pre_deny.Replace("(1=1)AND", "");
                while (pre_allow.Contains("(1=1)AND")) pre_allow = pre_allow.Replace("(1=1)AND", "");


                bool currdefaultisdeny = GOp.defaultisdeny;
                //if ((currdefaultisdeny == false) && (deny == "")) defaultisdeny = false;

                if (do_precheck) pre_allowcondition = QH.AppOr(pre_allowcondition,
                    combineclause(currdefaultisdeny, pre_allow, pre_deny,QH));

            }

            if (pre_allowcondition == "") {
                return null;
            }
            if (SQL) {
                pre_allowcondition = pre_allowcondition.Replace("&", " AND ");
                pre_allowcondition = pre_allowcondition.Replace("|", " OR ");
                pre_allowcondition = pre_allowcondition.Replace("!", " NOT ");
            }
            return pre_allowcondition;
        }

        public override void DeleteAllUnselectable(DataTable T) {

            string condition = SelectCondition(GetTableForReading(T),false);
            if (condition == null) return;


            try {
                DataRow[] foundNotPRE = null;
                foundNotPRE = T.Select("NOT(" + condition + ")");


                    foreach (DataRow fr in foundNotPRE) {
                        fr.Delete();
                    }
                    T.AcceptChanges();

                }            
            catch (Exception E) {
                QueryCreator.MarkEvent(E.Message);
            }
        }
        //static string AppendOrCondition(string s1, string s2){
        //    if (s1=="") return s2;
        //    if (s2=="") return s1;
        //    return s1+"OR"+s2;
        //}



		static string combineclause(bool defaultisdeny,string allow,string deny, QueryHelper QH){
            //if (defaultisdeny){
            //    if (allow==""){
            //        defaultisdeny=false;
            //    }				
            //}
            //else {
            //    if (deny==""){
            //        defaultisdeny=true;
            //    }
            //}
			if (defaultisdeny){
				///Current operation default is DENY (VIETA)
				if (allow!="") {
                    if (allow == "(1=1)") return "";
                    string currclause = QH.DoPar(allow);
                    if (deny != "") currclause = QH.AppAnd(allow,QH.Not(deny));
					return currclause;
					//DEFAULT VIETA --> PERMETTI AD  (ALLOW AND (NOT DENY))		
				}
                return "(1=0)";
				//else currclause is a "always-false"
			}
			else {
				///Current operation default is ALLOW
                if (allow == "(1=1)") return "";
				if (deny!="") {
                    string currclause = QH.Not(deny);
                    if (allow != "") currclause = QH.DoPar(QH.AppOr(currclause, allow));
					return currclause;
					//DEFAULT CONSENTI -> PERMETTI A (NOT DENY) OR ALLOW
				}
			}
			return "";


		}

		public static bool CheckCustomOperation(List<allowdeny> CustomGroupOperations,
			DataRow R){
			if (CustomGroupOperations==null)return true;
			if (CustomGroupOperations.Count==0) return true;
            CQueryHelper QHC= new CQueryHelper();
			string pre_allowcondition="";
			string post_allowcondition="";
			bool do_precheck;
			bool do_postcheck;

			switch (R.RowState){
				case DataRowState.Modified:
					do_precheck=true;
					do_postcheck=true;
					break;
				case DataRowState.Deleted:
					do_precheck=true;
					do_postcheck=false;
					break;
				case DataRowState.Added:
					do_precheck=  false;
					do_postcheck = true;
					break;
				default:
					do_precheck=  true;
					do_postcheck = false;
					break;
				
			}


			bool defaultisdeny=true;//general default
            bool therewascondition = false;
			foreach (allowdeny GOp in CustomGroupOperations){
				string allow= GOp.allow;
				string deny= GOp.deny;
                if ((allow != "" || deny != "")) therewascondition = true; ;

                string pre_allow = allow;
				string post_allow=allow;
				string pre_deny=deny;
				string post_deny=deny;
				if (allow.StartsWith("&")){
					pre_allow= allow.Substring(1);
					if (do_precheck)
						post_allow="";
					else 
						post_allow=pre_allow;
				}
				if (allow.StartsWith("%")){
					post_allow= allow.Substring(1);
					if (do_postcheck)
						pre_allow="";
					else 
						pre_allow=post_allow;
				}

				if (deny.StartsWith("&")){
					pre_deny= deny.Substring(1);
					if (do_precheck)
						post_deny="";
					else 
						post_deny=pre_deny;
				}
				if (deny.StartsWith("%")){
					post_deny= deny.Substring(1);
					if (do_postcheck)
						pre_deny="";
					else 
						pre_deny=post_deny;
				}

                if (pre_deny.StartsWith("AND(")) pre_deny = pre_deny.Substring(3);
                if (post_deny.StartsWith("AND(")) post_deny = post_deny.Substring(3);
                if (pre_allow.StartsWith("AND(")) pre_allow = pre_allow.Substring(3);
                if (post_allow.StartsWith("AND(")) post_allow = post_allow.Substring(3);

                if (pre_deny.Contains("AND(1=1)")) pre_deny = pre_deny.Replace("AND(1=1)", "");
                if (post_deny.Contains("AND(1=1)")) post_deny = post_deny.Replace("AND(1=1)", "");
                if (pre_allow.Contains("AND(1=1)")) pre_allow = pre_allow.Replace("AND(1=1)", "");
                if (post_allow.Contains("AND(1=1)")) post_allow = post_allow.Replace("AND(1=1)", "");

                if (pre_deny.Contains("(1=1)AND")) pre_deny = pre_deny.Replace("(1=1)AND", "");
                if (post_deny.Contains("(1=1)AND")) post_deny = post_deny.Replace("(1=1)AND", "");
                if (pre_allow.Contains("(1=1)AND")) pre_allow = pre_allow.Replace("(1=1)AND", "");
                if (post_allow.Contains("(1=1)AND")) post_allow = post_allow.Replace("(1=1)AND", "");

                //if (pre_allow == "(1=1)") pre_allow = "";
                //if (pre_deny == "(1=1)") pre_deny = "";
                //if (post_allow == "(1=1)") post_allow = "";
                //if (post_deny == "(1=1)") post_deny = "";

				bool currdefaultisdeny= GOp.defaultisdeny;
                //if  ((currdefaultisdeny ==false) && (deny=="")) defaultisdeny=false;

				if (do_precheck) pre_allowcondition=QHC.AppOr(pre_allowcondition,
					combineclause(currdefaultisdeny,pre_allow,pre_deny,QHC));
                
				if (do_postcheck) post_allowcondition=QHC.AppOr(post_allowcondition,
					combineclause(currdefaultisdeny,post_allow,post_deny,QHC));

			}

            if ((pre_allowcondition == "") && (post_allowcondition == "") && (therewascondition == true)
                  && defaultisdeny
                ) {
                return true;
            }
			
			try {
				DataRow []foundPRE =null;
				DataRow []foundPOST=null;
				bool okPRE=!do_precheck;
				bool okPOST=!do_postcheck;
				switch (R.RowState){
					case DataRowState.Modified:
						foundPRE = R.Table.Select(pre_allowcondition,null,DataViewRowState.ModifiedOriginal);
						foundPOST = R.Table.Select(post_allowcondition,null,DataViewRowState.ModifiedCurrent);
						break;
					case DataRowState.Deleted:
						foundPRE = R.Table.Select(pre_allowcondition,null,DataViewRowState.OriginalRows);
						break;
					case DataRowState.Added:
						foundPOST = R.Table.Select(post_allowcondition,null,DataViewRowState.CurrentRows);
						okPRE=true;
						break;
					default:
						foundPRE = R.Table.Select(pre_allowcondition);
						okPOST=true;
						break;
				
				}
			
				if (!okPRE){
					foreach(DataRow fr in foundPRE) {
						if (fr==R) okPRE=true;
					}
				}
				if (!okPOST){
					foreach(DataRow fr in foundPOST) {
						if (fr==R) okPOST=true;
					}
				}
				return okPOST && okPRE;

			}
			catch (Exception E) {
				QueryCreator.MarkEvent(E.Message);
			}
			return false;

		}

		public override bool CantUnconditionallyPost(DataTable T, string OpKind) {
			if (ReadOnly && (
				(OpKind.ToUpper()=="U")||(OpKind.ToUpper()=="I")||(OpKind.ToUpper()=="D")
				)) return true;
			List<allowdeny> Cond = GetCustomGroupOperation(T,OpKind);
			if (Cond==null) return false;
			if (Cond.Count==0) return false;
			foreach (allowdeny C in Cond){
				if (!C.defaultisdeny)return false;
				if (C.allow.Trim()!="")return false;
			}
			return true;
		}
		public override bool CanPrint(DataRow R) {
			if (R.Table.Columns["reportname"]==null) return true;
			string reportname= R["reportname"].ToString();
            List<allowdeny>  CustomGroupOperations = GetCustomGroupOperation(reportname, "P");
			if (CustomGroupOperations.Count>0)
				return CheckCustomOperation(CustomGroupOperations, R);
			else
				return true;

		}

        /// <summary>
        /// Calcola l'elenco dei gruppi di sicurezza di cui l'utente fa parte. Il risultato  messo in usr["usergrouplist"]
        /// </summary>
		public void CalculateGroupList(){
			if (usr["usergrouplist"]!=null) return;

            string filteruser = QHS.CmpEq("username", sys["user"]);
			DataTable TBUsers= RUN_SELECT("customuser","*",null,filteruser,null,false);
			if ((TBUsers==null)||(TBUsers.Rows.Count==0)){
				usr["usergrouplist"]="";
				return;
			}
			object userid= TBUsers.Rows[0]["idcustomuser"];
			sys["idcustomuser"]=userid;
            string filtergroups = QHS.CmpEq("idcustomuser", userid);

			DataTable groups = RUN_SELECT("customusergroup","*",null,filtergroups,
				null,null,true);
			string group=QHS.DistinctVal(groups.Select(),"idcustomgroup");
			usr["usergrouplist"]=group;
		}

		public string GetGroupList(){
			if (usr["usergrouplist"]==null) return null;
			return usr["usergrouplist"].ToString();

		}

		public override bool CanPost(DataRow R){
			if (ReadOnly) return false;
			string opkind;
			switch (R.RowState){
				case DataRowState.Added:
					opkind=RowChange.short_insert_descr;
					break;
				case DataRowState.Deleted:
					opkind= RowChange.short_delete_descr;
					break;
				default:
					opkind= RowChange.short_update_descr;
					break;
			}
			List<allowdeny> CustomGroupOperations = GetCustomGroupOperation(R.Table,opkind);
			if (CustomGroupOperations.Count>0)
				return CheckCustomOperation(CustomGroupOperations, R);
			else
				return true;
		}


		#endregion

		#region Gestione Variabili d'ambiente

		internal string MyDecryptKey(byte []B){
			return DecryptKey(B);
		}

		//fasespesamax	-->maxexpensephase
		//faseentratamax-->maxincomephase
		//fasemissione	-->itinerationphase
		//esercizio		-->ayear
		//faseordine	-->mandatephase
		//fasebilanciospesa-->expensefinphase
		//fasecreditoredebitorespesa -->expenseregphase
		//fasefondoricercaspesa	-->expenseresfundphase
		//fasebilpluriennalespesa	--> expensemultiphase
		//fasebilancioentrata-->incomefinphase
		//fasecreditoredebitoreentrata -->incomeregphase
		//fasefondoricercaentrata -->incomeresfundphase
		//fasebilpluriennaleentrata	--> incomemultiphase
        public void RecalcUserEnvironment() {
            int SS = metaprofiler.StartTimer("RecalcUserEnvironment");
            RecalcUserEnvironment(DBNull.Value,DBNull.Value);
            metaprofiler.StopTimer(SS);
        }

        void ResetConfig() {
            sys["filterrule"] = "";
            sys["Cfilterrule"] = "";
            sys["incomephase"] = 0;
            sys["itinerationphase"] = 0;
            sys["deferredexpensephase"] =0;
            sys["deferredincomephase"] = 0;
            sys["appropriationphase"] = 0;
            sys["assessmentphase"] = 0;
            sys["idsortingkind1"] = "";
            sys["idsortingkind2"] = "";
            sys["idsortingkind3"] = "";
            sys["idsor01"] = 0;
            sys["idsor02"] = 0;
            sys["idsor03"] = 0;
            sys["idsor04"] = 0;
            sys["idsor05"] = 0;

        }


        public void RecalcUserEnvironment(object idflowchart, object ndetail) {
            try {

                sys["maxexpensephase"] = DO_READ_VALUE("expensephase", null, "MAX(nphase)");
                if (idflowchart == null || idflowchart == DBNull.Value) {
                    try {
                        int N = RUN_SELECT_COUNT("sysobjects", QHS.CmpEq("name", "flowchartuser"), false);
                        if (N > 0) {
                            object currdate = DO_SYS_CMD("select getdate()");//sys["datacontabile"];
                            string f1 = QHS.AppAnd(QHS.CmpEq("FU.idcustomuser", sys["idcustomuser"]),
                                QHS.NullOrLe("FU.start", currdate), QHS.NullOrGe("FU.stop", currdate));
                            f1 = QHS.AppAnd(f1, QHS.CmpEq("F.ayear", GetSys("esercizio")));

                            DataTable TT = SQLRunner(
                                "SELECT F.idflowchart,FU.flagdefault,FU.ndetail from " +
                                "flowchart F join flowchartuser FU ON F.idflowchart=FU.idflowchart " +
                                "WHERE " + f1 + " ORDER BY FU.flagdefault DESC");

                            if ((TT != null) && (TT.Rows.Count > 0)) {
                                idflowchart = TT.Rows[0]["idflowchart"];
                                ndetail = TT.Rows[0]["ndetail"];
                            }
                        }


                    }
                    catch { }
                }
                if (sys["idcustomuser"] == null) sys["idcustomuser"] = DBNull.Value;
                sys["idflowchart"] = idflowchart;
                sys["ndetail"] = ndetail;
                string filtereserc = QHS.CmpEq("ayear", GetSys("esercizio"));

                //int NN = RUN_SELECT_COUNT("sysobjects", QHS.CmpEq("name", "config"), false);
                //if (NN > 0) {
                DataTable T = RUN_SELECT("config", "*", null, filtereserc, null, null, true);
                string filterrule = "";
                string Cfilterrule = "";
                if (T != null && T.Rows.Count > 0) {
                    DataRow S = T.Rows[0];
                    if (T.Columns.Contains("previsionkind")) {
                        if (S["previsionkind"].ToString().ToUpper() == "S") {
                            filterrule = QHS.CmpEq("flag_cash", "S");
                            Cfilterrule = QHC.CmpEq("flag_cash", "S");
                            sys["fin_kind"] = 2;
                        }
                        else {
                            if (S["secprevisionkind"].ToString().ToUpper() == "S") {
                                filterrule = QHS.CmpEq("flag_both", "S");
                                Cfilterrule = QHC.CmpEq("flag_both", "S");
                                sys["fin_kind"] = 3;
                            }
                            else {
                                filterrule = QHS.CmpEq("flag_comp", "S");
                                Cfilterrule = QHC.CmpEq("flag_comp", "S");
                                sys["fin_kind"] = 1;
                            }
                        }
                    }
                    else {
                        object flag = S["fin_kind"];
                        int iflag = 0;
                        if (flag != DBNull.Value) iflag = Convert.ToInt32(flag);
                        sys["fin_kind"] = iflag;
                        if (iflag == 2) {
                            filterrule = QHS.CmpEq("flag_cash", "S");
                            Cfilterrule = QHC.CmpEq("flag_cash", "S");
                        }
                        else {
                            if (iflag == 3) {
                                filterrule = QHS.CmpEq("flag_both", "S");
                                Cfilterrule = QHC.CmpEq("flag_both", "S");
                            }
                            else {
                                //flag==1
                                filterrule = QHS.CmpEq("flag_comp", "S");
                                Cfilterrule = QHC.CmpEq("flag_comp", "S");
                            }
                        }

                    }
                    sys["flagcredit"] = "S";
                    if (T.Columns.Contains("flagcredit")) {
                        if (S["flagcredit"].ToString().ToUpper() == "N") {
                            filterrule = QHS.AppAnd(filterrule, QHS.CmpEq("flag_credit", "N"));
                            Cfilterrule = QHC.AppAnd(Cfilterrule, QHC.CmpEq("flag_credit", "N"));
                            sys["flagcredit"] = "N";
                        }
                    }
                    sys["flagproceeds"] = "S";
                    if (T.Columns.Contains("flagproceeds")) {
                        if (S["flagproceeds"].ToString().ToUpper() == "N") {
                            filterrule = QHS.AppAnd(filterrule, QHS.CmpEq("flag_proceeds", "N"));
                            Cfilterrule = QHC.AppAnd(Cfilterrule, QHC.CmpEq("flag_proceeds", "N"));
                            sys["flagproceeds"] = "N";
                        }
                    }
                    sys["filterrule"] = filterrule;
                    sys["Cfilterrule"] = Cfilterrule;
                    sys["incomephase"] = S["incomephase"];
                    sys["itinerationphase"] = S["expensephase"];
                    sys["deferredexpensephase"] = S["deferredexpensephase"];
                    sys["deferredincomephase"] = S["deferredincomephase"];
                    sys["appropriationphase"] = S["appropriationphasecode"];
                    sys["assessmentphase"] = S["assessmentphasecode"];

                    object IDSOR = S["idsortingkind1"];
                    sys["idsortingkind1"] = IDSOR;
                    object TITLESOR;
                    if (IDSOR != null && IDSOR != DBNull.Value) {
                        TITLESOR = DO_READ_VALUE("sortingkind", QHS.CmpEq("idsorkind", IDSOR), "description");
                        sys["titlesortingkind1"] = TITLESOR;
                    }
                    else {
                        sys["titlesortingkind1"] = "";
                    }

                    IDSOR = S["idsortingkind2"];
                    sys["idsortingkind2"] = IDSOR;
                    if (IDSOR != null && IDSOR != DBNull.Value) {
                        TITLESOR = DO_READ_VALUE("sortingkind", QHS.CmpEq("idsorkind", IDSOR), "description");
                        sys["titlesortingkind2"] = TITLESOR;
                    }
                    else {
                        sys["titlesortingkind2"] = "";
                    }

                    IDSOR = S["idsortingkind3"];
                    sys["idsortingkind3"] = IDSOR;
                    if (IDSOR != null && IDSOR != DBNull.Value) {
                        TITLESOR = DO_READ_VALUE("sortingkind", QHS.CmpEq("idsorkind", IDSOR), "description");
                        sys["titlesortingkind3"] = TITLESOR;
                    }
                    else {
                        sys["titlesortingkind3"] = "";
                    }


                }
                else {
                    ResetConfig();
                }

                //}
                //else {
                //    // sys["filterrule"] non assegnato
                //    ResetConfig();
                //}

                sys["maxincomephase"] = DO_READ_VALUE("incomephase", null, "MAX(nphase)");
                try {
                    //NN = RUN_SELECT_COUNT("customobject", QHS.CmpEq("objectname", "uniconfig"), false);
                    //if (NN > 0) {
                    DataTable TT = RUN_SELECT("uniconfig", "*", null, null, null, null, true);
                    if (TT != null && T.Rows.Count > 0) {
                        DataRow U = TT.Rows[0];
                        sys["expensefinphase"] = U["expensefinphase"];
                        sys["expenseregphase"] = U["expenseregphase"];
                        sys["incomefinphase"] = U["incomefinphase"];
                        sys["incomeregphase"] = U["incomeregphase"];
                        sys["finusablelevel"] = DO_READ_VALUE("finlevel", filtereserc + "and(flag & 2)<>0", "min(nlevel)");
                        if (T.Columns.Contains("tree_upb_withdescr")) {
                            sys["upb_with_description"] = U["tree_upb_withdescr"].ToString().ToUpper();
                        }
                        sys["idsortingkind01"] = U["idsorkind01"];
                        sys["idsortingkind02"] = U["idsorkind02"];
                        sys["idsortingkind03"] = U["idsorkind03"];
                        sys["idsortingkind04"] = U["idsorkind04"];
                        sys["idsortingkind05"] = U["idsorkind05"];

                        foreach (string suffix in new string[] { "01", "02", "03", "04", "05" }) {
                            object IDSORKIND = sys["idsortingkind" + suffix];
                            string titlefield = "titlesortingkind" + suffix;
                            if (IDSORKIND != null && IDSORKIND != DBNull.Value) {
                                sys[titlefield] = DO_READ_VALUE("sortingkind", QHS.CmpEq("idsorkind", IDSORKIND), "description");
                            }
                            else {
                                sys[titlefield] = "";
                            }
                        }




                    }
                   
                }
                catch {
                }
                sys["mandatephase"] = sys["itinerationphase"];
                sys["estimatephase"] = sys["incomephase"];
                sys["invoiceexpensephase"] = sys["maxexpensephase"];
                //DO_READ_VALUE("invoicesetup","(ayear='"+GetEsercizio().ToString()+"')", "expensephase");
                sys["invoiceincomephase"] = sys["maxincomephase"];
                //DO_READ_VALUE("invoicesetup","(ayear='"+GetEsercizio().ToString()+"')", "incomephase");

                if (sys["idcustomuser"] != DBNull.Value) {
                    DataTable FU = RUN_SELECT("flowchartuser", "*", null,
                                                QHS.AppAnd(QHS.CmpEq("idflowchart", idflowchart),
                                                               QHS.CmpEq("ndetail", ndetail),
                                                               QHS.CmpEq("idcustomuser", sys["idcustomuser"])), null, false);
                    if (FU != null && FU.Rows.Count > 0 && FU.Columns.Contains("idsor01")) {
                        DataRow RFU = FU.Rows[0];
                        for (int i = 1; i <= 5; i++) {
                            string fname = "idsor0" + i.ToString();
                            if (RFU[fname] == DBNull.Value)
                                sys[fname] = 0;
                            else
                                sys[fname] = Convert.ToInt32(RFU[fname]);
                        }

                    }
                }
                else {
                    sys["idsor01"] = 0;
                    sys["idsor02"] = 0;
                    sys["idsor03"] = 0;
                    sys["idsor04"] = 0;
                    sys["idsor05"] = 0;
                }

                string sql_depmail =
                    "select coalesce(  (select email from sorting where idsor = <%sys[idsor01]%>), " +
                    "  (select email from sorting where idsor = <%sys[idsor02]%>), " +
                    "  (select email from sorting where idsor = <%sys[idsor03]%>), " +
                    "  (select email from sorting where idsor = <%sys[idsor04]%>), " +
                    "  (select email from sorting where idsor = <%sys[idsor05]%>) " +
                    " )";
                for (int nattr = 1; nattr <= 5; nattr++) {
                    object idsor_n = sys["idsor0" + nattr.ToString()];
                    if (idsor_n == null) idsor_n = DBNull.Value;
                    sql_depmail = sql_depmail.Replace("<%sys[idsor0" + nattr.ToString() + "]%>", QHS.quote(idsor_n));
                }
                object email_default = DO_SYS_CMD(sql_depmail, true);
                if (email_default == null) email_default = DBNull.Value;
                sys["defaultdepmail"] = email_default;

                

                DataTable EnvVar = RUN_SELECT("userenvironment", "*", null, QHS.CmpEq("idcustomuser", sys["idcustomuser"]),
                                    null, true);
                foreach (DataRow Var in EnvVar.Select(QHC.CmpEq("kind", "K"))) {
                    string varname = Var["variablename"].ToString();
                    string valore = Var["value"].ToString();
                    usr[varname] = valore;
                    QueryCreator.MarkEvent("usr[" + varname + "]=" + valore);
                }
                object idcustomuser = sys["idcustomuser"];

                foreach (DataRow Var in EnvVar.Select(QHC.CmpEq("kind", "S"))) {
                    string opkind = Var["kind"].ToString().ToUpper();
                    string varname = Var["variablename"].ToString();
                    string valore = Var["value"].ToString();
                    string result = null;
                    string spname = Compile(valore, true);
                    DataSet DRES;
                    if (spname.EndsWith("_withndet")) {
                        DRES = CallSP(spname, new object[] { GetEsercizio(), idcustomuser, idflowchart, ndetail, varname }
                                        , true);
                    }
                    else {
                        DRES = CallSP(spname, new object[] { GetEsercizio(), idcustomuser, idflowchart, varname }, true);
                    }
                    if (DRES != null) {
                        if (DRES.Tables.Count > 0) {
                            DataTable TRES = DRES.Tables[0];
                            string colname = TRES.Columns[0].ColumnName;
                            if (TRES.Columns.Count > 1 && TRES.Rows.Count == 1) {
                                string mustquote = TRES.Columns[1].ColumnName;
                                if (TRES.Rows[0][mustquote].ToString().ToUpper() == "S") {
                                    result = QueryCreator.ColumnValues(TRES, null, colname, false);
                                }
                                else {
                                    result = TRES.Rows[0][colname].ToString();
                                }
                            }
                            else {
                                result = QueryCreator.ColumnValues(TRES, null, colname, false);
                            }
                        }
                    }
                    if (result != null) {
                        usr[varname] = result;
                        QueryCreator.MarkEvent("usr[" + varname + "]=" + result);
                    }
                }

                foreach (DataRow Var in EnvVar.Select(QHC.CmpEq("kind", "C"))) {
                    string opkind = Var["kind"].ToString().ToUpper();
                    string varname = Var["variablename"].ToString();
                    string valore = Var["value"].ToString();
                    string result = null;
                    string cmd = Compile(valore, true);
                    DataTable RES = SQLRunner(cmd);
                    if (RES != null) {
                        string colname = RES.Columns[0].ColumnName;
                        result = QueryCreator.ColumnValues(RES, null, colname, false);
                    }
                    if (result != null) {
                        usr[varname] = result;
                        QueryCreator.MarkEvent("usr[" + varname + "]=" + result);
                    }
                }
                string err = LastError;

            }
            catch (Exception EE) {
                QueryCreator.MarkEvent(EE.Message);
            }
            string[] syskeys = EnumSysKeys();
            foreach (object o in syskeys) {
                if (sys[o] == null) continue;
                if (sys[o].GetType() != typeof(string)) continue;
                sys[o] = Compile(sys[o] as string, true);
            }
            string[] usrkeys = EnumUsrKeys();
            foreach (object o in usrkeys) {
                if (usr[o] == null) continue;
                if (usr[o].GetType() != typeof(string)) continue;
                usr[o] = Compile(usr[o] as string, true);
            }
        }



		#endregion

		#region Creazione Report

		public static ReportDocument GetReport(Easy_DataAccess Conn,
			DataRow ModuleReport,
			DataRow ParamsRow,
			out string ErrMess  
			){
			ErrMess=null;


			if (Conn.LocalToDB){
				try {
					ReportDocument R = Conn.MyGetReport(
						ModuleReport,
						ParamsRow,out ErrMess);
					return R;
				}
				catch (Exception E){
					ErrMess = E.Message;
					QueryCreator.MarkEvent(E.Message);
					return null;
				}
			}
			else {
				try {
					//ModuleReport va convertita in DataSet non tipizzato
					DataTable MyTableModuleReport = SingleTableClone(ModuleReport.Table,false);
					MyTableModuleReport.TableName= GetTableForReading(ModuleReport.Table);
					DataSet MyDSModuleReport = new DataSet("dummy");
					MyDSModuleReport.Tables.Add(MyTableModuleReport);
					DataRow MyRowModuleReport = MyTableModuleReport.NewRow();
					MyRowModuleReport.BeginEdit();
					foreach (DataColumn C in MyTableModuleReport.Columns) {
						MyRowModuleReport[C.ColumnName]= ModuleReport[C.ColumnName];
					}
					MyRowModuleReport.EndEdit();
					MyTableModuleReport.Rows.Add(MyRowModuleReport);


					//ParamsRow va convertita in DataSet non tipizzato
					DataTable MyTableParamsRow = SingleTableClone(ParamsRow.Table,true);
					MyTableParamsRow.TableName= GetTableForReading(ParamsRow.Table);
					DataSet MyDSParams = new DataSet("dummy");
					MyDSParams.Tables.Add(MyTableParamsRow);
					DataRow MyRowParamsRow = MyTableParamsRow.NewRow();
					MyRowParamsRow.BeginEdit();
					foreach (DataColumn C in MyTableParamsRow.Columns) {
						MyRowParamsRow[C.ColumnName]= ParamsRow[C.ColumnName];
					}
					MyRowParamsRow.EndEdit();
					MyTableParamsRow.Rows.Add(MyRowParamsRow);

					StringBuilder SBModuleReport = new StringBuilder(1000);
					StringWriter SWModuleReport = new StringWriter(SBModuleReport);
					MyDSModuleReport.WriteXml(SWModuleReport,XmlWriteMode.WriteSchema);

					StringBuilder SBParams = new StringBuilder(1000);
					StringWriter SWParams = new StringWriter(SBParams);
					MyDSParams.WriteXml(SWParams,XmlWriteMode.WriteSchema);

					byte [] A = Conn.byteMyGetReport(
						DataAccess.PackDataSet(Conn,MyDSModuleReport),
						DataAccess.PackDataSet(Conn,MyDSParams),out ErrMess);
					if (A==null) return null;
					string tempdir= System.IO.Path.GetTempPath();
					if (!tempdir.EndsWith("\\")) tempdir+="\\";
					string tempfilename= tempdir+System.Guid.NewGuid().ToString()+".rpt";
					FileStream F = new FileStream(tempfilename,FileMode.Create);
					F.Write(A,0,A.Length);
					F.Close();
					ReportDocument R = new ReportDocument();
					R.Load(tempfilename);
					File.Delete(tempfilename);
					return R;
				}
				catch (Exception E){
					ErrMess = E.Message;
					QueryCreator.MarkEvent(E.Message);
					return null;
				}
			}
		}

		public byte [] byteMyGetReport(byte []ModuleReport,
			byte [] Params,
			out string ErrMess){
			try {
				DataSet  ModuleReportDataSet = DataAccess.UnpackDataSet(this,ModuleReport);
				DataSet ParamsDataSet = DataAccess.UnpackDataSet(this, Params);

				DataRow ModuleReportRow = ModuleReportDataSet.Tables[0].Rows[0];
				DataRow ParamsRow = ParamsDataSet.Tables[0].Rows[0];

				ReportDocument R = MyGetReport(ModuleReportRow, ParamsRow, out ErrMess);
				if (R==null) return null;
				R.ExportOptions.ExportDestinationType = ExportDestinationType.DiskFile;
				R.ExportOptions.ExportFormatType = ExportFormatType.CrystalReport;
				string tempdir= System.IO.Path.GetTempPath();
				if (!tempdir.EndsWith("\\")) tempdir+="\\";
				string tempfilename= tempdir+System.Guid.NewGuid().ToString()+".rpt";

				DiskFileDestinationOptions diskOpts = new DiskFileDestinationOptions();
				diskOpts.DiskFileName = tempfilename;
				R.ExportOptions.DestinationOptions = diskOpts;

				R.Export();
				FileStream F = new FileStream(tempfilename,FileMode.Open);
				byte []A= new byte[F.Length];
				F.Read(A,0,Convert.ToInt32(F.Length));
				F.Close();
				File.Delete(tempfilename);
				return A;
			}
			catch (Exception E){
				ErrMess= "Creazione del report nel 3-tier fallita. Dettaglio: "+E.ToString();
				return null;
			}
		}

        bool responsabile_presente(DataRow Params) {
            if (Params.Table.Columns.Contains("idman")) {
                if ((Params["idman"].ToString() == "") || (Params["idman"].ToString() == "%")) {
                    //MessageBox.Show("E' necessario scegliere un responsabile (regola di sicurezza)");
                    return false;
                }
            }
            else {
                return false;
            }
            return true;
        }

        public ReportDocument MyGetReport(DataRow ModuleReportRow,
   DataRow ParamsRow,
   out string ErrMess
   ) {

            if (!CanPrint(ParamsRow)) {
                ErrMess = "La stampa con questi parametri non  consentita dalle regole di sicurezza";
                return null;
            }
            //Controlla la selezione null di bilancio/responsabile/upb
            object all_fin = usr["all_fin"];
            if ((all_fin != null) && (all_fin.ToString().ToLower().Equals("'n'"))) {
                if (ParamsRow.Table.Columns.Contains("idfin")) {
                    if ((ParamsRow["idfin"].ToString() == "") || (ParamsRow["idfin"].ToString() == "%")) {
                        if (!responsabile_presente(ParamsRow)) {
                            ErrMess = "E' necessario scegliere una voce di bilancio (regola di sicurezza)";
                            return null;
                        }
                    }
                    else {
                        DataTable TableFin = new DataTable();
                        TableFin.Columns.Add("idfin", typeof(int));
                        DataRow RFin = TableFin.NewRow();
                        RFin["idfin"] = ParamsRow["idfin"];
                        TableFin.Rows.Add(RFin);
                        if (!CanSelect(RFin)) {
                            ErrMess = "La voce di bilancio non poteva essere scelta  (regola di sicurezza)";
                            return null;
                        }
                    }
                }
                if (ParamsRow.Table.Columns.Contains("codefin")) {
                    if ((ParamsRow["codefin"].ToString() == "") || (ParamsRow["codefin"].ToString() == "%")) {
                        if (!responsabile_presente(ParamsRow)) {
                            ErrMess = "E' necessario scegliere una voce di bilancio (regola di sicurezza)";
                            return null;
                        }
                    }
                }
            }
            object all_upb = usr["all_upb"];
            if ((all_upb != null) && (all_upb.ToString().ToLower().Equals("'n'"))) {
                if (ParamsRow.Table.Columns.Contains("idupb")) {
                    if ((ParamsRow["idupb"].ToString() == "") || (ParamsRow["idupb"].ToString() == "%")) {
                        if (!responsabile_presente(ParamsRow)) {
                            ErrMess = "E' necessario scegliere un UPB (regola di sicurezza)";
                            return null;
                        }
                    }
                    else {
                        DataTable TableUpb = new DataTable();
                        TableUpb.Columns.Add("idupb", typeof(string));
                        DataRow RUpb = TableUpb.NewRow();
                        RUpb["idupb"] = ParamsRow["idupb"];
                        TableUpb.Rows.Add(RUpb);
                        if (!CanSelect(RUpb)) {
                            ErrMess = "L'upb non poteva essere scelto (regola di sicurezza)";
                            return null;
                        }
                    }
                }
                if (ParamsRow.Table.Columns.Contains("codeupb")) {
                    if ((ParamsRow["codeupb"].ToString() == "") || (ParamsRow["codeupb"].ToString() == "%")) {
                        if (!responsabile_presente(ParamsRow)) {
                            ErrMess = "E' necessario scegliere un UPB (regola di sicurezza)";
                            return null;
                        }
                    }
                }
            }

            object all_man = usr["all_man"];
            if ((all_man != null) && (all_man.ToString().ToLower() == "'n'")) {
                if (ParamsRow.Table.Columns.Contains("idman")) {
                    if ((ParamsRow["idman"].ToString() == "") || (ParamsRow["idman"].ToString() == "%")) {
                        ErrMess = "E' necessario scegliere un responsabile (regola di sicurezza)";
                        return null;
                    }
                }
            }

            object all_estimatekind = usr["all_estimatekind"];
            if ((all_estimatekind != null) && (all_estimatekind.ToString().ToLower() == "'n'")) {
                if (ParamsRow.Table.Columns.Contains("idestimkind")) {
                    if ((ParamsRow["idestimkind"].ToString() == "") || (ParamsRow["idestimkind"].ToString() == "%")) {
                        ErrMess = "E' necessario scegliere un tipo contratto attivo (regola di sicurezza)";
                        return null;
                    }
                }
            }

            object all_mandatekind = usr["all_mandatekind"];
            if ((all_mandatekind != null) && (all_mandatekind.ToString().ToLower() == "'n'")) {
                if (ParamsRow.Table.Columns.Contains("idmankind")) {
                    if ((ParamsRow["idmankind"].ToString() == "") || (ParamsRow["idmankind"].ToString() == "%")) {
                        ErrMess = "E' necessario scegliere un tipo contratto passivo (regola di sicurezza)";
                        return null;
                    }
                }
            }

            object all_pettycash = usr["all_pettycash"];
            if ((all_pettycash != null) && (all_pettycash.ToString().ToLower() == "'n'")) {
                if (ParamsRow.Table.Columns.Contains("idpettycash")) {
                    if ((ParamsRow["idpettycash"].ToString() == "") || (ParamsRow["idpettycash"].ToString() == "%")) {
                        ErrMess = "E' necessario scegliere un tipo fondo economale (regola di sicurezza)";
                        return null;
                    }
                }
            }

            object all_invoicekind = usr["all_invoicekind"];
            if ((all_invoicekind != null) && (all_invoicekind.ToString().ToLower() == "'n'")) {
                if (ParamsRow.Table.Columns.Contains("idinvkind")) {
                    if ((ParamsRow["idinvkind"].ToString() == "") || (ParamsRow["idinvkind"].ToString() == "%")) {
                        ErrMess = "E' necessario scegliere un tipo documento IVA (regola di sicurezza)";
                        return null;
                    }
                }
            }


            Hashtable ReportParams = new Hashtable();
            foreach (DataColumn C in ParamsRow.Table.Columns) {
                if (QueryCreator.IsPrimaryKey(ParamsRow.Table, C.ColumnName)) continue;
                ReportParams[C.ColumnName] = ParamsRow[C];
            }
            return ReportDispatcherClass.GetReport(this, ModuleReportRow, ReportParams, out ErrMess);
        }


		#endregion

        public bool ChangeFlowChart(){
            frmCambioFlowChart F = new frmCambioFlowChart(this);
            if (F.ShowDialog() != DialogResult.OK) return false;
            if (F.cmbFlowChart.SelectedIndex < 0) return false;
            if (F.cmbFlowChart.SelectedValue == null) return false;
            string idflowchart = F.cmbFlowChart.SelectedValue.ToString();
            return ChangeFlowChart(F.idflowchart,F.ndetail);
        }
        
        public bool ChangeFlowChart(object idflowchart,object ndetail) {
            string idcustomuser = GetSys("idcustomuser") as string;

            if (idflowchart != null && idflowchart != DBNull.Value) {
                object currdate = sys["datacontabile"];
                string f1 = QHS.AppAnd(QHS.CmpEq("FU.idcustomuser", idcustomuser),
                    QHS.NullOrLe("FU.start", currdate), QHS.NullOrGe("FU.stop", currdate));
                f1 = QHS.AppAnd(f1, QHS.CmpEq("F.ayear", GetSys("esercizio")));
                f1 = QHS.AppAnd(f1, QHS.CmpEq("F.idflowchart", idflowchart));
                f1 = QHS.AppAnd(f1, QHS.CmpEq("F.idflowchart", idflowchart));


                DataTable TT = SQLRunner(
                    "SELECT F.idflowchart  from " +
                    "flowchart F join flowchartuser FU ON F.idflowchart=FU.idflowchart " +
                    "WHERE " + f1 + " ORDER BY FU.flagdefault DESC");
                if (TT.Rows.Count == 0) return false;
            }
                      
            RecalcUserEnvironment(idflowchart,ndetail);
            ReadAllGroupOperations();
            return true;
        }

		public bool Is_Member(string group) {
			if (group==null)return false;
			try {
                string cmd = "IS_ROLEMEMBER"; 
                group = group.ToLower();
                if (group == "sysadmin" || group == "dbcreator" || group == "diskadmin" || group == "processadmin" ||
                            group == "serveradmin" || group == "setupadmin" ||
                            group == "securityadmin")
                    cmd = "IS_SRVROLEMEMBER";


                object O = DO_SYS_CMD("select " + cmd + " (" +QHS.quote(group) + ","+QHS.quote(sys["user"])+") AS Q");
                if ((O != null) && (O.ToString() == "1")) {
                    return true;
                }
                else {
                    return false;
                }

                //DataAccess da = new DataAccess(
                //    false,
                //    sys["dsn"].ToString(),
                //    sys["server"].ToString(),
                //    sys["database"].ToString(),
                //    sys["user"].ToString(),
                //    DecryptKey((byte[]) sys["password"]),
                //    GetEsercizio(),
                //    (DateTime) sys["datacontabile"]);			
                //if (da==null) return false;

				
                //DataTable t = da.SQLRunner("select "+cmd+"("+QueryCreator.quotedstrvalue(group,true)+")");
                //da.Destroy();
                //string result = t.Rows[0][0].ToString();
                //return result == "1";
			}
			catch (Exception E){
				MarkException("IS_Member",E);
				return false;
			}
		}
        public override QueryHelper GetQueryHelper() {
            return new SqlServerQueryHelper();
        }

	}



	public class Meta_EasyDispatcher: EntityDispatcher {
		public Meta_EasyDispatcher(DataAccess Conn):base(Conn){}
		override public MetaData DefaultMetaData(DataAccess Conn, string table){
			return new Meta_easydata(Conn, this, table);
		}
	}

	/// <summary>
	/// Base class for all easy MetaData
	/// </summary>
	public class Meta_easydata: MetaData {
		public Meta_easydata(DataAccess Conn, MetaDataDispatcher Dispatcher, string table):
			base(Conn,Dispatcher,table) {
			ManagedByDB=false;
			ErrorLogUrl= "http://liceasy.ath.cx/LiveLog/doeasy.aspx";
			NotesFieldName="txt";
			OleNotesFieldName="rtf";
		}

		override public  void LogError(string errmsg,Exception E){
			if (Conn==null) return;
			if (ErrorLogUrl==null) return;
			try {
				//object omsg = null; //Conn.DO_SYS_CMD("sp_exp_licenzauso '1'");
				//if (omsg!=null) msg=omsg.ToString()+";";
				if (InsertMode) errmsg+="{Insert}";
				if (EditMode) errmsg+="{Edit}";
				if (IsEmpty) errmsg+="{Empty}";
				if (LinkedForm!=null) errmsg+="{"+LinkedForm.Name+"}";

				string msg=
					"nomedb="+QueryCreator.quotedstrvalue(GetSys("database"),true)+";"+
					"server="+QueryCreator.quotedstrvalue(GetSys("server"),true)+";"+
					"username="+QueryCreator.quotedstrvalue(GetSys("user"),true)+";"+
					"machine="+QueryCreator.quotedstrvalue(GetSys("computername"),false)+";"+
					"dep="+QueryCreator.quotedstrvalue(GetSys("userdb"),false)+";"+
					"esercizio="+QueryCreator.quotedstrvalue(GetSys("esercizio"),false)+";"+
					"datacont="+QueryCreator.quotedstrvalue(((DateTime) GetSys("datacontabile")).ToString("d"),false)+";";


				if (Conn!=null){
					string lasterr= Conn.SecureGetLastError();
					if ((lasterr!="")&&(lasterr!=null)){
						msg+="dberror="+QueryCreator.quotedstrvalue(lasterr,false)+";";

					}
																										
				}

				msg+="err="+QueryCreator.quotedstrvalue(errmsg,false);
				if (E!=null){
					msg+=";msg="+QueryCreator.quotedstrvalue(
						QueryCreator.GetErrorString(E),false);
				}
                //testmsg(msg);

				byte [] B2 = DataAccess.CryptString(msg);
                string SS2 = QueryCreator.ByteArrayToString(B2);

                SendMessage SM = new SendMessage(SS2, "z");
                Thread TT = new Thread(new ThreadStart(SM.Send));
                TT.Start();
                

                //WebClient W = new WebClient();
                //W.BaseAddress="http://80.181.3.246/LiveLog/";
                //byte [] B = W.DownloadData("http://80.181.3.246/LiveLog/doeasy.aspx?z="+SS2);
			}
			catch {
			}


		}
        
		public override void LogError(string mess) {
			LogError(mess,null);
		}


        void testmsg(string S) {
            int i = 0;
            while(i < S.Length) {
                //prende l'identificatore all'inizio di S, fino all'uguale
                int poseq = S.IndexOf("=");
                if(poseq <= 0) break;
                string fieldname = S.Substring(0, poseq).Trim();
                string myfield = translateToOld(fieldname);
                if(fieldname == "iddb") myfield = "iddb";
                S = S.Substring(poseq + 1);
                char SEP = S[0];
                if(SEP != '\'' && SEP != '#') break;
                int index = 1;
                while(index < S.Length) {
                    //ad ogni iterazione index  la posizione da cui partire (inclusa) per la ricerca del prossimo apice
                    index = S.IndexOf(SEP, index);
                    if(index <= 0) break;
                    if((index + 1) >= S.Length) break; //ha trovato l'apice (finale)
                    if(S[index + 1] != SEP) break; //ha trovato l'apice (non  seguito da un altro apice)
                    index = index + 2;
                }
                if((index < 1) || (index >= S.Length)) break; //non ha trovato l'apice
                if(S[index] != SEP) break;  //non ha trovato l'apice
                string val = S.Substring(1, index - 1);
                if(SEP == '\'') {
                    val = val.Replace("''", "'"); //toglie il doppio apice in tutto val
                }
                else {
                    val = "#" + val + "#";
                    DateTime D = Convert.ToDateTime(val);
                    QueryCreator.MarkEvent("D=" + D.ToString());
                }
                QueryCreator.MarkEvent(myfield + "=" + val);
                if(index + 2 >= S.Length) break; //Se S  finita esci
                S = S.Substring(index + 2);
            }

        }

        string translateToOld(string news) {
            if(news == "address1") return "indirizzo_1";
            if(news == "address2") return "indirizzo_2";
            if(news == "agency") return "universita";
            if(news == "agencycode") return "codiceente";
            if(news == "annotations") return "note";
            if(news == "cf") return "codicefiscale";
            if(news == "country") return "provincia";
            if(news == "department") return "dipartimento";
            if(news == "departmentcode") return "codicedipartimento";
            if(news == "departmentname") return "nomeente";
            if(news == "expiringlic") return "scadenzalic";
            if(news == "expiringman") return "scadenzaman";
            if(news == "iddb") return "iddbcliente";
            if(news == "idreg") return "codicecreddeb";
            if(news == "lickind") return "tipolic";
            if(news == "licstatus") return "statolic";
            if(news == "mankind") return "tipoman";
            if(news == "manstatus") return "statoman";
            if(news == "location") return "localita";
            if(news == "lt") return "lastmodtimestamp";
            if(news == "lu") return "lastmoduser";
            if(news == "ct") return "createtimestamp";
            if(news == "cu") return "createuser";
            if(news == "swmorecode") return "codiceswmore";
            if(news == "swmoreflag") return "flagswmore";
            if(news == "p_iva") return "partitaiva";
            if(news == "phonenumber") return "telefono";
            if(news == "referent") return "rifcont";
            if(news == "sent") return "inviato";
            return news;
        }


		override public void DescribeColumns(DataTable T, string ListingType){
			base.DescribeColumns(T,ListingType);
			foreach(DataColumn C in T.Columns){
				if (C.Caption.Equals("lu")) C.Caption="";
				if (C.Caption.Equals("lt")) C.Caption="";
				if (C.Caption.Equals("cu")) C.Caption="";
				if (C.Caption.Equals("ct")) C.Caption="";
				if (C.Caption.Equals("rtf"))C.Caption="";
				if (C.Caption.Equals("txt"))C.Caption="";
//				if (C.Caption.Equals("denyu"))C.Caption="";
//				if (C.Caption.Equals("denyd"))C.Caption="";
			}
		}

		override public void SetDefaults(DataTable T){
			base.SetDefaults(T);
			SetDefault(T,"lu","-");
			SetDefault(T,"cu","-");
			SetDefault(T,"lt", DateTime.Now);
			SetDefault(T,"ct", DateTime.Now);
            foreach (string ss in new string[] { "idsor01", "idsor02", "idsor03", "idsor04", "idsor05" }) {
                object O = GetSys(ss);
                if (O==null )  continue;
                if (O == DBNull.Value) continue;
                if (Convert.ToInt32(O) == 0) continue;
                if (!T.Columns.Contains(ss))continue;
                SetDefault(T, ss, O);
            }
            
//			try {
//				if (!T.Columns["denyu"].AllowDBNull) SetDefault(T,"denyu","0");
//				if (!T.Columns["denyd"].AllowDBNull) SetDefault(T,"denyd","0");
//			}
//			catch {
//			}
		}

		public override string GetFilterForInsert(DataTable T) {
			if (T==null) return base.GetFilterForInsert (T);
			if (T.Columns["active"]!=null){
				return "((active is null)or(active='')or(active='S'))";
			}
			return null;
		}
        public override string GetFilterForSearch(DataTable T) {
            if (T == null) return base.GetFilterForSearch(T);
            if (T.Columns["active"] != null) {
                return "((active is null)or(active='')or(active='S'))";
            }
            return null;
        }


		protected override void InsertCopyColumn(DataColumn C, DataRow Source, DataRow Dest) {
			if (C.ColumnName=="adate")return;
			base.InsertCopyColumn (C, Source, Dest);
		}

		override public PostData Get_PostData(){
			return new Easy_PostData();
		}

		public override bool CanSelect(DataRow R) {
			if (R.Table.Columns.Contains("ayear")){
                if (R["ayear"] != DBNull.Value) {
                    if (Convert.ToInt32(R["ayear"]) != Convert.ToInt32(GetSys("esercizio"))) {
                        ShowClientMsg("La riga scelta non appartiene all'esercizio corrente e non pu essere selezionata.",
                                            "Errore", MessageBoxButtons.OK);                        
                        return false;
                    }
                }
			}
			return base.CanSelect (R);
		}

        public override bool IsValid(DataRow R, out string errmess, out string errfield) {
            foreach (DataColumn C in R.Table.Columns) {
                if (C.DataType != typeof(DateTime)) continue;
                if (C.ColumnName != "start" && C.ColumnName != "stop" && C.ColumnName != "adate") continue;
                if (R[C.ColumnName] == DBNull.Value) continue;
                if (R[C].ToString() == QueryCreator.EmptyDate().ToString()) continue;
                DateTime T = (DateTime) R[C.ColumnName];
                if (T.Year < 1900 || T.Year > 2050) {
                    string message= "Si sta inserendo una data che precede il 1900 o segue il 2050. Si  certi dell'operazione ?";
                    if (!this.ShowClientMsg(message, "Attenzione!", MessageBoxButtons.OKCancel)) {
                        errfield = C.ColumnName;
                        errmess = null; // "Data non valida.";
                        return false;
                    }
                }
            }
            return base.IsValid(R, out errmess, out errfield);
        }
	

	}


	public class easy_node_dispatcher : node_dispatcher{
		string level_table;
		string level_field;
		string descr_level_field;
		string selectable_level_field;
		string descr_field;
		string code_string;

		/// <summary>
		/// Node builder
		/// </summary>
		/// <param name="level_table">Table with tree-level description</param>
		/// <param name="level_field">level field of tree_table rows</param>
		/// <param name="descr_level_field">level description, field of level_table </param>
		/// <param name="selectable_level_field">field that contains "flagoperativo" in level table</param>
		/// <param name="descr_field">field to put in tooltip</param>
		/// <param name="code_string">field to display in tree view near level description</param>
		public easy_node_dispatcher(
			string level_table, 
			string level_field,
			string descr_level_field,
			string selectable_level_field,
			string descr_field,
			string code_string
			) {
			this.level_table= level_table;
			this.level_field= level_field;
			this.descr_field= descr_field;
			this.selectable_level_field=selectable_level_field;
			this.descr_level_field= descr_level_field;
			this.code_string=code_string;
		}
		override public tree_node GetNode(DataRow Parent, DataRow Child){
			return new easy_tree_node(level_table, level_field, descr_level_field, selectable_level_field,
				descr_field, code_string, Child);
		}
	}

	public class easy_tree_node: tree_node {
		string level_field;
		string descr_level_field;
		string selectable_level_field;
		string descr_field;
		string level_table;
		string code_string;
        

		public easy_tree_node(string level_table, 
			string level_field,
			string descr_level_field,
			string selectable_level_field,
			string descr_field,
			string code_string,
			DataRow R):base(R){
			this.level_table = level_table;
			this.level_field= level_field;
			this.descr_level_field=descr_level_field;
			this.selectable_level_field= selectable_level_field;
			this.descr_field= descr_field;
			this.code_string=code_string;
		}

		public int level(){
			return Convert.ToInt32(Row[level_field].ToString());
		}

		/// <summary>
		/// Label that appears in treeview for each node
		/// </summary>
		/// <returns></returns>
		override public string Text(){
            string S = DescrLevel();
            if (!row_exists()) return S;
            if (descr_field!= null && Row.Table.Columns.Contains(descr_field)) {
                S = "";
                if (code_string != null) {
                    if (S != "") S = S + " ";
                    S = S + Row[code_string];
                }
                if (Row[descr_field].ToString() != "") {
                    if (S != "") S = S + " ";
                    S = S + Row[descr_field];
                }
            }
            else {
                if (code_string != null) {
                    if (S != "") S = S + " ";
                    S = S + Row[code_string];
                }

            }
			return S;
		}
                
		bool row_exists(){
			if (Row==null) return false;
			if (Row.RowState== DataRowState.Deleted) return false;
			if (Row.RowState== DataRowState.Detached) return false;
			return true;
		}
		/// <summary>
		/// String that should appear in tooltip
		/// </summary>
		/// <returns></returns>
		override public string ToolTip(){
			if (!row_exists()) return "";
			if (descr_field!=null) return Row[descr_field].ToString();
			if (code_string!=null) return Row[code_string].ToString();
			return "";
		}

		/// <summary>
		/// True if "selectable" and with "no chidren"
		/// </summary>
		/// <returns></returns>
		override public bool CanSelect(){
			if (!row_exists()) return false;
			if (selectable_level_field==null) return true;
			DataRow Lev = LevelRow();
			if (Lev[selectable_level_field].ToString().ToLower()=="n") return false;
			if (HasAutoChildren()) return false;
			return true;           
		}
        
		public DataRow LevelRow(){
			if (!row_exists()) return null;
			foreach (DataRelation R in Row.Table.ParentRelations){
				if (R.ParentTable.TableName==level_table){
					return Row.GetParentRow(R);
				}
			}
			return null;
		}
		public bool HasAutoChildren(){
			DataRelation Rfound=null;
			foreach (DataRelation R in Row.Table.ParentRelations){
				if (R.ParentTable.TableName== Row.Table.TableName){
					Rfound = R;
				}
			}
			if (Rfound==null) return false;
			return (Row.GetChildRows(Rfound).Length>0);
		}

		public string DescrLevel(){
			if (!row_exists()) return "";
			DataRow Lev = LevelRow();
			if (Lev==null)return "";
			return Lev[descr_level_field].ToString();
		}

	}

    public class SendMessage {
        public byte[]Result;
        public string message;
        public string type;
        public SendMessage(string message, string type) {
            this.message = message;
            this.type = type;
        }
        public void Send() {
            try {
                WebClient W = new WebClient();
                W.BaseAddress = "http://liceasy.ath.cx/LiveLog/";
                Result = W.DownloadData("http://liceasy.ath.cx/LiveLog/doeasy.aspx?" + type + "=" + message);
            }
            catch {               
            }

        }
    }




}



