using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.Win32;
using System.IO;
using metadatalibrary;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;
using System.Runtime.Remoting.Channels.Http;
using System.Net;
using System.Threading;
using System.Text;

namespace metaeasylibrary
{
	/// <summary>
	/// Summary description for frmEasyConnect.
	/// </summary>
	public class frmEasyConnect : System.Windows.Forms.Form
	{

		/// <summary>
		/// Output DataAccess Object
		/// </summary>
		public Easy_DataAccess MyDataAccess=null;

		private System.Windows.Forms.NumericUpDown dmnEsercizio;
		private System.Windows.Forms.Button btnAnnulla;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Label lblDataCont;
		private System.Windows.Forms.Label lblEsercizio;
		private System.Windows.Forms.TextBox txtDataCont;
		private System.Windows.Forms.Label lblPassword;
		private System.Windows.Forms.Label lblUser;
		private System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.TextBox txtUser;
		private System.Windows.Forms.Label lblEnte;
		private System.Windows.Forms.ComboBox cmbEnte;
		string[,] enti;
		/// <summary>
		/// String to search in ODBC registry for DB description. Es. "Easy Local Source"
		/// </summary>
		//public string DBIdentifier;//="Easy Local Source";
		bool GoodData;
		bool DontUpdate;

		LastConnection LastAcc;
        string LastUser = "";
		private System.Windows.Forms.TextBox txtDataBase;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox txtServer;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox chkAvanzate;
		private System.Windows.Forms.TextBox txtDSN;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox chkAddToList;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox txtDipartimento;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox txtOldPwd;
        private Button btnDelete;
        private TextBox txtLDAP;
        private Label label6;
		string LastDB="";

		void ReadLastConnection(){
			LastAcc= new LastConnection();
			try {
				LastAcc.ReadXml(AppDomain.CurrentDomain.BaseDirectory+"lastconn.xml", XmlReadMode.ReadSchema);
			}
			catch {
				return;
			}
			LastUser= LastAcc.lastconn.Rows[0]["lastuser"].ToString();
			LastDB= LastAcc.lastconn.Rows[0]["lastdb"].ToString();

			//Selects
		}

		void WriteLastConnection(){
			try {
				LastAcc= new LastConnection();
				DataRow R = LastAcc.lastconn.NewRow();
				R["lastuser"] = LastUser;;
				R["lastdb"] = LastDB;
				LastAcc.lastconn.Rows.Add(R);
				LastAcc.WriteXml("lastconn.xml", XmlWriteMode.WriteSchema);
			}
			catch {
			}
		}

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		void SetDBList(DataSet dbl){
			string curpath = AppDomain.CurrentDomain.BaseDirectory;
			if (!curpath.EndsWith("\\"))curpath+="\\";
			try {
				dbl.WriteXml(curpath+"dblist.xml", XmlWriteMode.WriteSchema);
			}
			catch (Exception E){
				QueryCreator.ShowException(E);
			}
		}
		void CheckExistsDBList(){
			string curpath = AppDomain.CurrentDomain.BaseDirectory;
			if (!curpath.EndsWith("\\"))curpath+="\\";
			if (File.Exists(curpath+"dblist.xml")) return;
			dblist newdblist = new dblist();
			UpdateList(newdblist);
			SetDBList(newdblist);
		}
        /// <summary>
        /// Legge la lista dei db da file xml
        /// </summary>
        /// <returns></returns>
		DataSet GetDBList(){
			string curpath = AppDomain.CurrentDomain.BaseDirectory;
			if (!curpath.EndsWith("\\"))curpath+="\\";
			if (!File.Exists(curpath+"dblist.xml")) return new dblist();
			DataSet newdblist = new DataSet();
			try {
				newdblist.ReadXml(curpath+"dblist.xml",XmlReadMode.ReadSchema);
                if (!newdblist.Tables["db"].Columns.Contains("ldapserver")) {
                    newdblist.Tables["db"].Columns.Add(new DataColumn("ldapserver", typeof(string)));

                }
			}
			catch (Exception E) {
				QueryCreator.ShowException(E);
				UpdateList(newdblist);
			}
			return newdblist;
		}


		/// <summary>
		/// Aggiunge una o pi righe a dblist prendendole dall'ODBC list
		/// </summary>
		/// <param name="dbl"></param>
		bool UpdateList(DataSet dbl){
			try {
				string curruser = System.Environment.UserName.ToUpper();
				if (dbl.Tables["db"].Select("ntuser="+
					QueryCreator.quotedstrvalue(curruser,false)).Length>0) return false;

				//Adds a dummy row so it will never come here again
                DataRow dummy = dbl.Tables["db"].NewRow();
				dummy["ntuser"]= curruser;
				dummy["description"]="**dummy**";
                dbl.Tables["db"].Rows.Add(dummy);
				//MergeODBCToList(dbl);
				return true;

			}
			catch (Exception E){
				QueryCreator.ShowException(E);
			}
			return false;
		}

		void AddCurrentToList(){
			string filterusr = "(description="+	QueryCreator.quotedstrvalue(txtDSN.Text,false)+")AND"+
							"(ntuser="+	QueryCreator.quotedstrvalue(System.Environment.UserName.ToUpper(),false)+")";
			string filterall = "(description="+	QueryCreator.quotedstrvalue(txtDSN.Text,false)+")AND"+
				"(ntuser='*')";
			DataSet dbl = GetDBList();
			DataTable DB = dbl.Tables["db"];
			DataRow dbr;
			DataRow []foundall = DB.Select(filterall);
			if (foundall.Length>0) return;
			DataRow []foundusr = DB.Select(filterusr);
			if (foundusr.Length>0) {
				dbr = foundusr[0];
				if ((dbr["server"].ToString()==txtServer.Text)&&
					(dbr["database"].ToString()==txtDataBase.Text)&&
					//(dbr["trusted"].ToString()== (chkIntegrata.Checked? "S":"N"))&&
					(dbr["department"].ToString()==txtDipartimento.Text)&&
                    (dbr["ldapserver"].ToString() == txtLDAP.Text)
					)return;
				dbr["server"]= txtServer.Text;
				dbr["database"] = txtDataBase.Text;
				dbr["department"] = txtDipartimento.Text;
				dbr["user"]= txtUser.Text;
                dbr["ldapserver"] = txtLDAP.Text;
				SetDBList(dbl);
			}
			else {
				dbr = DB.NewRow();
				dbr["description"]= txtDSN.Text;
				dbr["server"]= txtServer.Text;
				dbr["database"] = txtDataBase.Text;
				dbr["ntuser"] = System.Environment.UserName.ToUpper();
				dbr["user"]= txtUser.Text;
				dbr["department"] = txtDipartimento.Text;
                dbr["ldapserver"] = txtLDAP.Text;
                DB.Rows.Add(dbr);
				SetDBList(dbl);
			}

		}

		void RemoveCurrentFromList(){
			string filterusr = "(description="+	QueryCreator.quotedstrvalue(txtDSN.Text,false)+")AND"+
				"(ntuser="+	QueryCreator.quotedstrvalue(System.Environment.UserName.ToUpper(),false)+")";
			string filterall = "(description="+	QueryCreator.quotedstrvalue(txtDSN.Text,false)+")AND"+
				"(ntuser='*')";
			DataSet dbl = GetDBList();
			DataTable DB = dbl.Tables["db"];
			DataRow []foundusr = DB.Select(filterusr);
			if (foundusr.Length==0) return;
			foundusr[0].Delete();
			DB.AcceptChanges();
			SetDBList(dbl);
            int i = cmbEnte.SelectedIndex;
            cmbEnte.Items.RemoveAt(cmbEnte.SelectedIndex);
            if (i <= cmbEnte.Items.Count) cmbEnte.SelectedIndex = i;
		}

		void DoAddRemoveItemFromList(){
			if (chkAddToList.Checked) AddCurrentToList();
			//else    RemoveCurrentFromList();
			
		}

		public frmEasyConnect()
		{
			
			string curruser = System.Environment.UserName.ToUpper();

			InitializeComponent();
			txtDataCont.Text = DateTime.Today.ToShortDateString();
			//this.DBIdentifier= SourceName;
			ReadLastConnection();
			DontUpdate=true;

			CheckExistsDBList();
			DataSet dbl = GetDBList();
			if (UpdateList(dbl)) SetDBList(dbl);
            
            DataTable DB = dbl.Tables["db"];
            DB.CaseSensitive = false;
			DataRow []dbrow = DB.Select("((ntuser="+QueryCreator.quotedstrvalue(curruser,false)+")"+
					"OR(ntuser='*'))AND(description<>'**dummy**')","description");


			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			int nsubkey = dbrow.Length;
			enti = new String[nsubkey,6];
			int index = 0;
			int defaultindex=-1;
			foreach (DataRow DBR in dbrow) {
				string str =  DBR["description"].ToString();
				enti[index,0]= str;
				if (str==LastDB) defaultindex=index;
				enti[index,1]= DBR["server"].ToString().Trim();
				enti[index,2]= DBR["database"].ToString().Trim();
				enti[index,3]= DBR["user"].ToString();
				enti[index,4]= DBR["department"].ToString();
                enti[index, 5] = DBR["ldapserver"].ToString();
                index++;				
			}

			cmbEnte.BeginUpdate();
			for (int i = 0; i < index; i++) {
				try {
					cmbEnte.Items.Add(enti[i,0]);					
				}
				catch {
					//parte rimanente degli enti
				}
				
			}
			cmbEnte.EndUpdate();

			dmnEsercizio.Text= DateTime.Today.Year.ToString();
			if (index>0) cmbEnte.SelectedIndex=0;
			if (dbrow.Length==0){
				MessageBox.Show(this,
						"Non ci sono enti configurati. Riempire le informazioni Nome Ente, Server, DataBase "+
						"relative al database a cui ci si vuole connettere.",
						"Avviso");
				chkAvanzate.Checked=true;
				chkAddToList.Checked=true;
			}
			MyDataAccess= null;
			GoodData=true;
			DontUpdate=false;
			cmbEnte_SelectedIndexChanged(null,null);
			if (defaultindex!=-1) cmbEnte.SelectedIndex=defaultindex;
			if ((!txtUser.ReadOnly)&&txtUser.Enabled) txtUser.Text= LastUser;
			chkAvanzate_CheckedChanged(null,null);
            txtPassword.Focus();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.dmnEsercizio = new System.Windows.Forms.NumericUpDown();
            this.btnAnnulla = new System.Windows.Forms.Button();
            this.btnOk = new System.Windows.Forms.Button();
            this.lblDataCont = new System.Windows.Forms.Label();
            this.lblEsercizio = new System.Windows.Forms.Label();
            this.txtDataCont = new System.Windows.Forms.TextBox();
            this.lblPassword = new System.Windows.Forms.Label();
            this.lblUser = new System.Windows.Forms.Label();
            this.txtPassword = new System.Windows.Forms.TextBox();
            this.txtUser = new System.Windows.Forms.TextBox();
            this.lblEnte = new System.Windows.Forms.Label();
            this.cmbEnte = new System.Windows.Forms.ComboBox();
            this.txtDataBase = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.txtServer = new System.Windows.Forms.TextBox();
            this.label1 = new System.Windows.Forms.Label();
            this.chkAvanzate = new System.Windows.Forms.CheckBox();
            this.txtDSN = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.chkAddToList = new System.Windows.Forms.CheckBox();
            this.label4 = new System.Windows.Forms.Label();
            this.txtDipartimento = new System.Windows.Forms.TextBox();
            this.label5 = new System.Windows.Forms.Label();
            this.txtOldPwd = new System.Windows.Forms.TextBox();
            this.btnDelete = new System.Windows.Forms.Button();
            this.txtLDAP = new System.Windows.Forms.TextBox();
            this.label6 = new System.Windows.Forms.Label();
            ((System.ComponentModel.ISupportInitialize)(this.dmnEsercizio)).BeginInit();
            this.SuspendLayout();
            // 
            // dmnEsercizio
            // 
            this.dmnEsercizio.Location = new System.Drawing.Point(272, 112);
            this.dmnEsercizio.Maximum = new decimal(new int[] {
            2038,
            0,
            0,
            0});
            this.dmnEsercizio.Minimum = new decimal(new int[] {
            1996,
            0,
            0,
            0});
            this.dmnEsercizio.Name = "dmnEsercizio";
            this.dmnEsercizio.Size = new System.Drawing.Size(52, 20);
            this.dmnEsercizio.TabIndex = 5;
            this.dmnEsercizio.Value = new decimal(new int[] {
            1996,
            0,
            0,
            0});
            this.dmnEsercizio.ValueChanged += new System.EventHandler(this.dmnEsercizio_ValueChanged);
            // 
            // btnAnnulla
            // 
            this.btnAnnulla.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnAnnulla.Location = new System.Drawing.Point(248, 152);
            this.btnAnnulla.Name = "btnAnnulla";
            this.btnAnnulla.Size = new System.Drawing.Size(80, 24);
            this.btnAnnulla.TabIndex = 7;
            this.btnAnnulla.Text = "Annulla";
            this.btnAnnulla.Click += new System.EventHandler(this.btnAnnulla_Click);
            // 
            // btnOk
            // 
            this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnOk.Location = new System.Drawing.Point(160, 152);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(80, 24);
            this.btnOk.TabIndex = 6;
            this.btnOk.Text = "OK";
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // lblDataCont
            // 
            this.lblDataCont.Location = new System.Drawing.Point(24, 112);
            this.lblDataCont.Name = "lblDataCont";
            this.lblDataCont.Size = new System.Drawing.Size(88, 16);
            this.lblDataCont.TabIndex = 21;
            this.lblDataCont.Text = "Data Contabile:";
            this.lblDataCont.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lblEsercizio
            // 
            this.lblEsercizio.Location = new System.Drawing.Point(208, 112);
            this.lblEsercizio.Name = "lblEsercizio";
            this.lblEsercizio.Size = new System.Drawing.Size(56, 16);
            this.lblEsercizio.TabIndex = 20;
            this.lblEsercizio.Text = "Esercizio:";
            this.lblEsercizio.TextAlign = System.Drawing.ContentAlignment.BottomRight;
            // 
            // txtDataCont
            // 
            this.txtDataCont.Location = new System.Drawing.Point(120, 112);
            this.txtDataCont.Name = "txtDataCont";
            this.txtDataCont.Size = new System.Drawing.Size(72, 20);
            this.txtDataCont.TabIndex = 4;
            this.txtDataCont.Text = "5/22/2002";
            this.txtDataCont.TextChanged += new System.EventHandler(this.txtDataCont_TextChanged);
            this.txtDataCont.Leave += new System.EventHandler(this.txtDataCont_Leave);
            // 
            // lblPassword
            // 
            this.lblPassword.Location = new System.Drawing.Point(16, 80);
            this.lblPassword.Name = "lblPassword";
            this.lblPassword.Size = new System.Drawing.Size(104, 16);
            this.lblPassword.TabIndex = 18;
            this.lblPassword.Text = "Parola di accesso:";
            this.lblPassword.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // lblUser
            // 
            this.lblUser.Location = new System.Drawing.Point(48, 48);
            this.lblUser.Name = "lblUser";
            this.lblUser.Size = new System.Drawing.Size(64, 16);
            this.lblUser.TabIndex = 17;
            this.lblUser.Text = "Utente:";
            this.lblUser.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtPassword
            // 
            this.txtPassword.Location = new System.Drawing.Point(120, 80);
            this.txtPassword.Name = "txtPassword";
            this.txtPassword.PasswordChar = '*';
            this.txtPassword.Size = new System.Drawing.Size(200, 20);
            this.txtPassword.TabIndex = 3;
            // 
            // txtUser
            // 
            this.txtUser.Location = new System.Drawing.Point(120, 48);
            this.txtUser.Name = "txtUser";
            this.txtUser.Size = new System.Drawing.Size(200, 20);
            this.txtUser.TabIndex = 2;
            // 
            // lblEnte
            // 
            this.lblEnte.Location = new System.Drawing.Point(56, 16);
            this.lblEnte.Name = "lblEnte";
            this.lblEnte.Size = new System.Drawing.Size(56, 16);
            this.lblEnte.TabIndex = 14;
            this.lblEnte.Text = "Ente:";
            this.lblEnte.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // cmbEnte
            // 
            this.cmbEnte.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.cmbEnte.ItemHeight = 13;
            this.cmbEnte.Location = new System.Drawing.Point(120, 16);
            this.cmbEnte.Name = "cmbEnte";
            this.cmbEnte.Size = new System.Drawing.Size(200, 21);
            this.cmbEnte.TabIndex = 1;
            this.cmbEnte.SelectedIndexChanged += new System.EventHandler(this.cmbEnte_SelectedIndexChanged);
            // 
            // txtDataBase
            // 
            this.txtDataBase.Location = new System.Drawing.Point(112, 256);
            this.txtDataBase.Name = "txtDataBase";
            this.txtDataBase.Size = new System.Drawing.Size(232, 20);
            this.txtDataBase.TabIndex = 11;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 256);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 28;
            this.label2.Text = "Database";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtServer
            // 
            this.txtServer.Location = new System.Drawing.Point(112, 224);
            this.txtServer.Name = "txtServer";
            this.txtServer.Size = new System.Drawing.Size(232, 20);
            this.txtServer.TabIndex = 10;
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(24, 224);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(80, 16);
            this.label1.TabIndex = 26;
            this.label1.Text = "Server";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // chkAvanzate
            // 
            this.chkAvanzate.Location = new System.Drawing.Point(8, 152);
            this.chkAvanzate.Name = "chkAvanzate";
            this.chkAvanzate.Size = new System.Drawing.Size(80, 24);
            this.chkAvanzate.TabIndex = 6;
            this.chkAvanzate.TabStop = false;
            this.chkAvanzate.Text = "Dettagli";
            this.chkAvanzate.CheckedChanged += new System.EventHandler(this.chkAvanzate_CheckedChanged);
            // 
            // txtDSN
            // 
            this.txtDSN.Location = new System.Drawing.Point(112, 192);
            this.txtDSN.Name = "txtDSN";
            this.txtDSN.Size = new System.Drawing.Size(232, 20);
            this.txtDSN.TabIndex = 9;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 192);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(100, 23);
            this.label3.TabIndex = 31;
            this.label3.Text = "Nome Ente";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // chkAddToList
            // 
            this.chkAddToList.Checked = true;
            this.chkAddToList.CheckState = System.Windows.Forms.CheckState.Checked;
            this.chkAddToList.Location = new System.Drawing.Point(232, 354);
            this.chkAddToList.Name = "chkAddToList";
            this.chkAddToList.Size = new System.Drawing.Size(112, 24);
            this.chkAddToList.TabIndex = 13;
            this.chkAddToList.Text = "Elenca tra gli enti";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(16, 288);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(88, 20);
            this.label4.TabIndex = 33;
            this.label4.Text = "Dipartimento";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // txtDipartimento
            // 
            this.txtDipartimento.Location = new System.Drawing.Point(112, 288);
            this.txtDipartimento.Name = "txtDipartimento";
            this.txtDipartimento.Size = new System.Drawing.Size(232, 20);
            this.txtDipartimento.TabIndex = 12;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 386);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(352, 24);
            this.label5.TabIndex = 34;
            this.label5.Text = "Vecchia Password (da inserire se si  cambiata la propria password dall\'esterno d" +
                "el programma)";
            this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // txtOldPwd
            // 
            this.txtOldPwd.Location = new System.Drawing.Point(104, 418);
            this.txtOldPwd.Name = "txtOldPwd";
            this.txtOldPwd.PasswordChar = '*';
            this.txtOldPwd.Size = new System.Drawing.Size(240, 20);
            this.txtOldPwd.TabIndex = 14;
            // 
            // btnDelete
            // 
            this.btnDelete.Location = new System.Drawing.Point(78, 354);
            this.btnDelete.Name = "btnDelete";
            this.btnDelete.Size = new System.Drawing.Size(102, 23);
            this.btnDelete.TabIndex = 35;
            this.btnDelete.Text = "Non mostrare pi";
            this.btnDelete.UseVisualStyleBackColor = true;
            this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
            // 
            // txtLDAP
            // 
            this.txtLDAP.Location = new System.Drawing.Point(112, 318);
            this.txtLDAP.Name = "txtLDAP";
            this.txtLDAP.Size = new System.Drawing.Size(232, 20);
            this.txtLDAP.TabIndex = 36;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(16, 318);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(88, 20);
            this.label6.TabIndex = 37;
            this.label6.Text = "Server LDAP";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // frmEasyConnect
            // 
            this.AcceptButton = this.btnOk;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.CancelButton = this.btnAnnulla;
            this.ClientSize = new System.Drawing.Size(406, 458);
            this.Controls.Add(this.txtLDAP);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.btnDelete);
            this.Controls.Add(this.txtOldPwd);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.txtDipartimento);
            this.Controls.Add(this.txtDSN);
            this.Controls.Add(this.txtDataBase);
            this.Controls.Add(this.txtServer);
            this.Controls.Add(this.txtDataCont);
            this.Controls.Add(this.txtPassword);
            this.Controls.Add(this.txtUser);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.chkAddToList);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.chkAvanzate);
            this.Controls.Add(this.dmnEsercizio);
            this.Controls.Add(this.btnAnnulla);
            this.Controls.Add(this.btnOk);
            this.Controls.Add(this.lblDataCont);
            this.Controls.Add(this.lblEsercizio);
            this.Controls.Add(this.lblPassword);
            this.Controls.Add(this.lblUser);
            this.Controls.Add(this.lblEnte);
            this.Controls.Add(this.cmbEnte);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Name = "frmEasyConnect";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Connessione al DB";
            this.TopMost = true;
            ((System.ComponentModel.ISupportInitialize)(this.dmnEsercizio)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion



		private void cmbEnte_SelectedIndexChanged(object sender, System.EventArgs e) {
			if (DontUpdate) return;
			int selectedIndex = cmbEnte.SelectedIndex;
			if (selectedIndex<0) return;
			//chkAvanzate.Checked=false;
			txtServer.Text= enti[selectedIndex,1];
			txtDataBase.Text = enti[selectedIndex,2];
			txtDSN.Text= enti[selectedIndex,0];
			txtDipartimento.Text = enti[selectedIndex, 4];
			txtUser.Text= enti[selectedIndex, 3];
            txtLDAP.Text = enti[selectedIndex, 5];
			chkAddToList.Checked=true;
		}

		private void btnOk_Click(object sender, System.EventArgs e) {
			
			string user22 = txtUser.Text;


			int selectedIndex = cmbEnte.SelectedIndex;


			if (!GoodData) {
				MessageBox.Show("Dati non validi");
				this.DialogResult= DialogResult.None;
				return;
			}

			string server = txtServer.Text; // enti[selectedIndex,1];
			string remserver="";
			string dbserver="";
            string user=txtUser.Text.Trim();
            string pwd= txtPassword.Text.Trim();

			server=server.Trim();
			if (server.StartsWith("[")){
				int end= server.IndexOf("]",1);
				if (end>=1){
					remserver=server.Substring(1,end-1).Trim();
					dbserver= server.Substring(end+1).Trim();
				}
				else {
					dbserver= server.Trim();
				}
			}
			else {
				dbserver=server.Trim();
			}
            string dep = txtDipartimento.Text.Trim();
            string ext_user = user;
            string sys_user = user;

            string ldapserver = txtLDAP.Text.Trim();
            if (ldapserver != "") {
                string new_user = "";
                string new_pwd = "";
                try {
                    bool res2 = GetLDapAuth(ldapserver, user, pwd, dep, 
                            out new_user, out new_pwd, out sys_user);
                    if (res2) {
                        user = new_user;
                        pwd = new_pwd;
                    }
                }
                catch (Exception E) {
                    QueryCreator.ShowException(this,"Autenticazione al server LDAP fallita", E);
                }

            }
			
			string database = txtDataBase.Text; // enti[selectedIndex,2];
			DateTime T = Convert.ToDateTime(txtDataCont.Text);
			string DSN = txtDSN.Text; // enti[selectedIndex,0];
			EasyDataAccessLoader DAL =null;
			if (remserver!=""){
				try {
					try {

						BinaryClientFormatterSinkProvider clientProvider = 
							new BinaryClientFormatterSinkProvider();
						//BinaryServerFormatterSinkProvider serverProvider = 
						//	new BinaryServerFormatterSinkProvider();
//						serverProvider.TypeFilterLevel = 
//							System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;

						IDictionary props = new Hashtable();
						props["port"] = 8989;
						string s = System.Guid.NewGuid().ToString();
						props["name"] = s;
//						props["typeFilterLevel"] = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full;
						TcpChannel chan = new TcpChannel(
							props,clientProvider,null);
						ChannelServices.RegisterChannel(chan,true);


						//HttpChannel chan = new HttpChannel(8989);
						//TcpChannel chan = new TcpChannel(8989);
						//ChannelServices.RegisterChannel(chan);
						//RemotingConfiguration.RegisterWellKnownClientType(typeof(EasyDataAccessLoader),
						//	"tcp://"+remserver+":8989/EasyDataAccessLoader.rem");

					}
					catch (Exception E){
						QueryCreator.MarkEvent(E.Message);
					}

					
			
					DAL = (EasyDataAccessLoader) Activator.GetObject(
						typeof(EasyDataAccessLoader),"tcp://"+
								remserver+ ":8989"+
								"/EasyDataAccessLoader");

				}
				catch (Exception){
					//QueryCreator.ShowException(E);
					DAL=null;
				}
			}

			string msg=null;
			string dettaglio=null;
			if (DAL!=null){
				//SSPIEnabled = (enti[selectedIndex,3]== "Yes");
				try {
					 MyDataAccess = DAL.GetDataAccess(DSN,
								Easy_DataAccess.CryptPassword( dbserver.Trim()),
								Easy_DataAccess.CryptPassword(database.Trim()),
                            Easy_DataAccess.CryptPassword(user), 
							Easy_DataAccess.CryptPassword(pwd),
							Easy_DataAccess.CryptPassword(txtDipartimento.Text),
							Easy_DataAccess.CryptPassword(txtOldPwd.Text),
						 T.Year, T, out msg, out dettaglio);						
					if (MyDataAccess!=null){
						MyDataAccess.LocalToDB=false;
						MessageBox.Show("Connesso in 3-tier.");
					}				
					else {
						QueryCreator.ShowError(this, msg, dettaglio);
					}

				}
				catch (Exception E){
					QueryCreator.ShowException(E);
					DAL=null;
					MyDataAccess=null;
				}



			}


			if (MyDataAccess==null) {
				MyDataAccess = Easy_DataAccess.getEasyDataAccess("DSN", dbserver.Trim(), database.Trim(),
					user, pwd, txtOldPwd.Text.Trim(),
					txtDipartimento.Text.Trim(), 
					T.Year, T, out msg, out dettaglio);

//				//SSPIEnabled = (enti[selectedIndex,3]== "Yes");
//				if (SSPIEnabled) {
//					MyDataAccess = new Easy_DataAccess(DSN, dbserver.Trim(), database.Trim(), T.Year, T);
//				}
//				else {
//					MyDataAccess = new Easy_DataAccess(DSN, dbserver.Trim(), database.Trim(), txtUser.Text, txtPassword.Text,
//						T.Year, T);	
//				}
			}
			if (msg=="") msg=null;
			string dbversion="-";
			bool res = msg == null;
			if (res) {
				res = MyDataAccess.Open();
				msg = "Non  stato possibile effettuare il collegamento al dipartimento.";
				dettaglio = MyDataAccess.LastError;
			}
			object iddb=DBNull.Value;
			if (res) {
                MyDataAccess.external_user = ext_user;
                if (sys_user != user) {
                    MyDataAccess.SetSys("user", sys_user);
                    MyDataAccess.SetUsr("usergrouplist", null);
                    MyDataAccess.CalculateGroupList();
                    MyDataAccess.RecalcUserEnvironment();
                    MyDataAccess.ReadAllGroupOperations();
                }

				try  {
					dbversion= MyDataAccess.DO_READ_VALUE("updatedbversion",null,"max(versionname)") as string;
				}
				catch {
				}
				try  {
					iddb= MyDataAccess.DO_READ_VALUE("license",null,"iddb");
				}
				catch {
				}
				MyDataAccess.Close();
			}


			if (!res) {
				MyDataAccess = null;
				QueryCreator.ShowError(this, msg, dettaglio);
				if (!chkAddToList.Checked) DoAddRemoveItemFromList();
				this.DialogResult= DialogResult.None;
			} else {
				try {

					//Leggo la versione del file locale
					string localdir= Application.StartupPath;
					string localversion="-";
					try{
						StreamReader read=new StreamReader(localdir+"\\versionesw.txt");
						localversion=read.ReadLine();
						read.Close();
					}
					catch  {
					}
					string machinename = Environment.MachineName;
					string username = (string) MyDataAccess.GetSys("userdb");

					string data= 
						"nomedb="+QueryCreator.quotedstrvalue(database.Trim(),true)+";"+
						"server="+QueryCreator.quotedstrvalue(server.Trim(),true)+";"+
						"dep="+QueryCreator.quotedstrvalue(username.Trim(),true)+";"+
						"dbversion="+QueryCreator.quotedstrvalue(dbversion,true)+";"+
						"swversion="+QueryCreator.quotedstrvalue(localversion,false)+";"+
						"username="+QueryCreator.quotedstrvalue(user22,true)+";"+
						"machine="+QueryCreator.quotedstrvalue(machinename,false)+";"+
						"iddb="+QueryCreator.quotedstrvalue(iddb,false);

					Logger L = new Logger(MyDataAccess,data);
					Thread TT = new Thread(new ThreadStart(L.start));
					TT.Start();

				}
				catch{}
			
				
				LastUser= txtUser.Text;
				LastDB= DSN;
				WriteLastConnection();
				DoAddRemoveItemFromList();
			}
		}
        bool GetLDapAuth(string serverldap, string user, string pwd, string dep,
                            out string db_user, out string db_pwd, out string sys_user) {
            db_user = user;
            db_pwd = pwd;
            sys_user = user;
            CQueryHelper QHC= new CQueryHelper();
            Hashtable H= new Hashtable();
            H["usr"]=user;
            H["pwd"]=pwd;
            H["dep"]=dep;
            string SS= DataAccess.GetStringFromHashTable(H);
            Hashtable HH = DataAccess.GetHashFromString(SS);

            WebClient W = new WebClient();
            if (!serverldap.EndsWith("/")) serverldap += "/";
            W.BaseAddress = serverldap;
            byte[] B = W.DownloadData(serverldap + "LDAPService.aspx?x=" + SS);
            if ((B != null) && (B.Length > 0)) {
                string S = Encoding.Default.GetString(B);
                if (!S.StartsWith("Errore")) {
                    Hashtable H1 = DataAccess.GetHashFromString(S);
                    db_pwd = H1["pwd"].ToString();
                    db_user = H1["usr"].ToString();
                    sys_user = H1["vusr"].ToString();
                }
                else {
                    return false;
                }
            }
            return true;
        }
        

		private void btnAnnulla_Click(object sender, System.EventArgs e) {
			MyDataAccess=null;					
		}
		private void dmnEsercizio_ValueChanged(object sender, System.EventArgs e) {
			
			if (DontUpdate) return;
			DontUpdate = true;
			DateTime T;
			try {
                int anno = Convert.ToInt32(dmnEsercizio.Value);
                if (anno < DateTime.Now.Year) {
                    T = new DateTime(anno, 12, 31);
                    txtDataCont.Text = T.ToShortDateString();
                }
                if (anno == DateTime.Now.Year) {
                    string S = txtDataCont.Text;
                    T = Convert.ToDateTime(S);
                    T = new DateTime(anno, DateTime.Now.Month, DateTime.Now.Day);
                    txtDataCont.Text = T.ToShortDateString();
                }
                if (anno > DateTime.Now.Year) {
                    T = new DateTime(anno, 1, 1);
                    txtDataCont.Text = T.ToShortDateString();
                }
				GoodData=true;
			}
			catch {
				GoodData= false;
			}
			DontUpdate=false;
			
		}
		private void txtDataCont_Leave(object sender, System.EventArgs e) {
			if (DontUpdate) return;
			DontUpdate = true;
			try {
				string S = txtDataCont.Text;
				DateTime T;
				T = Convert.ToDateTime(S);
				dmnEsercizio.Value = T.Year;
				GoodData=true;
			}
			catch {
				GoodData= false;
			}
			DontUpdate=false;
		}

		private void chkAvanzate_CheckedChanged(object sender, System.EventArgs e) {
			if (chkAvanzate.Checked){
				Height=483;
			}
			else {
				Height=216;
			}

		}


        private void txtDataCont_TextChanged(object sender, EventArgs e) {

        }

        private void btnDelete_Click(object sender, EventArgs e) {
            RemoveCurrentFromList();
        }


	}
	class Logger {
		string data;
		DataAccess Conn;
		public Logger (DataAccess Conn, string data){
			this.data=data;
			this.Conn=Conn.Duplicate();
		}
		public void start() {
			try {
				byte []B2 = DataAccess.CryptString(data); //dati criptati
				string SS = QueryCreator.ByteArrayToString(B2); //stringa dei dati criptati

				WebClient W = new WebClient();
				W.BaseAddress="http://liceasy.ath.cx/LiveLog/";
                //byte [] B = W.DownloadData("http://liceasy.ath.cx/LiveLog/Do.aspx?x="+SS);
                byte[] B = W.DownloadData("http://liceasy.ath.cx/LiveLog/DoEasy.aspx?x=" + SS);
				if ((B!=null)&&(B.Length>0)){
					W.Dispose();
					object XXX = Conn.DO_SYS_CMD("exp_license '0'");
					if (XXX!=null){
						string XX = XXX.ToString();
						XX= data+";"+XX.ToString();
						B2 = DataAccess.CryptString(XX);
						string SS2 = QueryCreator.ByteArrayToString(B2);
						W = new WebClient();
                        W.BaseAddress = "http://liceasy.ath.cx6/LiveLog/";
                        B = W.DownloadData("http://liceasy.ath.cx/LiveLog/DoEasy.aspx?y=" + SS2);
						Conn.DO_SYS_CMD("UPDATE license set sent='S'");
					}
				}
				W.Dispose();
				Conn.Destroy();
			}
			catch (Exception E) {
				string S31 = E.Message;
				Conn.Destroy();
			}
		}
	}
}
